disp('Solving example 12.2 ...')
%Last edited: Jan. 28, 2008, IK

p=24; a1=-0.9; a2=0.5; b1=0.2;
H=tf([0,b1],[1,a1,a2],1,'variable','z^-1');
figure(1), bode(H), shg
h=impulse(H); %SOSh=sum(h.^2), C1n=sum(h(1:end-1).*h(2:end)),
figure(2), impulse(H); shg
A=sqrt(2); sigma=1; f1=0.015; varx=1;
H1=bode(H,f1)
vary=H1^2*varx,
C1s=vary;
varFL=0.180*2^(-2*p)*( (a1^2+a2^2+a1^2+a2^2 )*vary ...
  +2*a1*a2*C1s+b1^2*varx+vary)

varFL2=0.180*2^(-2*p)*vary

return
global N_for_test_only
if isempty(N_for_test_only), Nx=2e3; else Nx=1.5*N_for_test_only; end

Ns=100; x=sin(1.5*2*pi*[1:Nx]'/Ns);
for rtype={'fix','float'}
%for rtype={'float','fix'}
  y=zeros(Nx,1); yq=y;
  rtype=rtype{1};
  F=1/0.4^2*(a1^2*1/(1-a1^2)+a2^2*1/(1-a2^2)-2*a1*a2/(1-a1*a2))
  if strcmp(rtype,'fix')
    disp('Fixed-point roundoff, B=32')
    Q=qstruct(struct('type','fixed-point','B',B,'fract',B-1,'ovf','c')); q=lsb(-1,Q);
    fprintf('q = %.4g = 2^%.f\n',q,log2(q))
    x=(1-q)*x;
    RMSth=3*q^2/12*F;
  elseif strcmp(rtype,'float')
    disp('Floating-point roundoff, p=24')
    Q=qstruct(struct('type','floating-point','p',p,'Emin',-126,'Emax',127));  
    RMSth=0.180*2^(-2*p)*1/2*(0.6^2+0.05^2+0.55^2+0.4^2+1)*F;
  else
    error('Unknown rtype')
  end
  qstructget(Q)
  RMSth
  for n=3:Nx
    y(n)=0.6*y(n-1)-0.05*y(n-2)+0.4*x(n);
    yq(n)=roundq(roundq(roundq(0.6*y(n-1),Q)-roundq(0.05*y(n-2),Q),Q)+...
      roundq(0.4*roundq(x(n),Q),Q),Q);
    if rem(n,50)==2, fprintf('.'), end %sign of life
    if rem(n,50*50)==1, disp(' '), end
  end
  plot((yq(150:end)-y(150:end))), shg
  disp(' ')
  RMSnu2=mean((yq(150:end)-y(150:end)).^2)
end
