disp('Solving exercise 12.3 ...')

close all
p=8; 
%Emin=-126; Delta=2^Emin;
Delta=1;
q=pow2(-(p-1))*Delta;
sigma=25*Delta; mu=0;
%
M=8; dx=q/M;
N=1e6;
x=sigma*randn(N,1);
[y,dcomp]=compress(x,Delta,'p');
%
figure(1)
[NB,X]=hist(y,M*15); dx=mean(diff(X));
bar(X,NB/N/dx,1), shg
xlabel(sprintf('N = %.1e',N))
ylimplot=8;
set(gca,'xlim',[-ylimplot,ylimplot],'ylim',[0,0.25])
saveprobfig(1,['figp_13_4a.eps'])
%
nu=q*round(y/q)-y;
figure(2)
[NB,X]=hist(nu,2*M); dx=mean(diff(X));
bar(X,NB/N/dx,1), shg
xlabel(sprintf('N = %.1e',N))
nlimplot=0.006;
set(gca,'xlim',[-nlimplot,nlimplot],'ylim',[0,200])
saveprobfig(2,['figp_13_4b.eps'])

fprintf('var{nu} = %.6g*q^2/12\n',(std(nu)^2)/(q^2/12))
r=corrcoef(nu,y);
fprintf('r_{nu,y} = %.2e\n',r(1,2));
