disp('Solving exercise 12.8 ...')

close all

p=8; 
%Emin=-126; Delta=2^Emin;
Delta=1;
q=pow2(-(p-1))*Delta;
sigma=25*Delta;  mu=30*Delta;
%
M=8; dx=q/M;
x=[-3*sigma+dx/2:dx:3*sigma]+mu;
global N_for_test_only
if ~isempty('N_for_test_only'), x=[-3*sigma+dx/2:6*sigma/N_for_test_only/10:3*sigma]; end
fx=1/sqrt(2*pi)/sigma*exp(-(x-mu).^2/2/sigma^2);
[y,dcomp]=compress(x,Delta,'p');
%figure(1), plot(x,y), shg, figure(2), plot(x,dcomp), set(gca,'ylim',[0,1.1]), figure(2)
%
ylim=1.1*max(abs(y));
nlim=(1+4/M)*q/2;
nuFLlim=q/2*pow2(ceil(log2(3*sigma/Delta))-1);
nuFL=[-nuFLlim+dx/2:dx:nuFLlim]; fn=zeros(size(nuFL));
nuEXPlim=0.6;
nuEXP=[-nuEXPlim+dx/2:dx:nuEXPlim]; fnEXP=zeros(size(nuEXP));
P=0;
for ii=1:length(x)
  if ii==1, fprintf('ii = 1, '), end
  %
  nuFLii=expand(q*round(y(ii)/q),Delta)-x(ii);
  [niifound,ind]=min(abs(nuFL-nuFLii));
  fn(ind)=fn(ind)+fx(ii);
  %
  nuEXPii=round(log2(abs(x(ii))/Delta)-0.5)-(log2(abs(x(ii))/Delta)-0.5);
  [niifound,ind]=min(abs(nuEXP-nuEXPii));
  fnEXP(ind)=fnEXP(ind)+fx(ii);
  %
  P=P+fx(ii)*dx;
  %
  if rem(ii,1000)==0
    if (rem(ii,10000)>1000)|(rem(ii,10000)==0), fprintf(', '), end
    fprintf('%.0f',ii)
    if rem(ii,10000)==0, fprintf('\n'), end
  end
end %for ii
if rem(ii,10000)~=0, fprintf('\n'), end
P
ic=0;
for label='ab'
  ic=ic+1;
  figure(label-'a'+1)
  if (label-'a'+1)==1
    nuFLlimplot=0.25;
    plot(nuFL,fn), set(gca,'xlim',[-nuFLlimplot,nuFLlimplot],'ylim',[0,15])
  else
    nuEXPlimplot=0.6;
    plot(nuEXP,fnEXP); set(gca,'xlim',[-nuEXPlimplot,nuEXPlimplot],'ylim',[0,1.5])
    xlabel(sprintf('q/2 = %.4g',q/2))
  end
  %ylimits=get(gca,'ylim'); ylimits(1)=0; set(gca,'ylim',ylimits)
  shg
  saveprobfig(label-'a'+1,['figp_13_9',label,'.eps'])
end %for label
