disp('Solving exercise 15.12 ...')

err=cell(5,3); err{2,1}='Noise'; err{3,1}='Sine'; err{4,1}='Sine2'; err{5,1}='Sine3'; 
err{1,2}='N=256'; err{1,3}='N=258'; 
err_eps=err; format short
sigma=1/sqrt(3); A=sqrt(2)/sqrt(3);
for sig='ns'
  for N=[256,258]
    if strcmp(sig,'n')
      x=sigma*randn(N,1);
    else
      x=A*sin(2*pi*4.5*[1:N]/N);
    end
    X1=fft(x);
    X2=fft(ifft(X1));
    X3=fft(ifft(X2));
    X4=fft(ifft(X3));
    fprintf(['Signal: %s, N = %.0f\n'],sig,N)
    rmsX=sqrt(mean(abs(X2-X1).^2)/2)
    rmsX2=sqrt(mean(abs(X3-X2).^2)/2)
    rmsX3=sqrt(mean(abs(X4-X3).^2)/2)
    err{('n'-sig)/('n'-'s')+1+1,N/2-127+1}=rmsX;
    err_eps{('n'-sig)/('n'-'s')+1+1,N/2-127+1}=rmsX/eps;
    if strcmp(sig,'s')
      err{('n'-sig)/('n'-'s')+1+2,N/2-127+1}=rmsX2;
      err_eps{('n'-sig)/('n'-'s')+1+2,N/2-127+1}=rmsX2/eps;
      err{('n'-sig)/('n'-'s')+1+3,N/2-127+1}=rmsX3;
      err_eps{('n'-sig)/('n'-'s')+1+3,N/2-127+1}=rmsX3/eps;
    end
  end
end
err, err_eps