disp('Solving exercise 16.2 ...')

close all
rand('seed',0), randn('seed',0) %initialize random generators 
N=120; 
Q=qstruct(struct('B',8,'fb',7,'coding','t')); %define quantizer
x=bin2num('0.1100101',Q);
y=zeros(N+1,1); y(1)=bin2num('0.1',Q);
yq=y; ydq=y;
a=bin2num('0.11101',Q);
if ~isequal(a,qfix(a,Q)); error('a is not properly quantized'), end
qfix(a,Q,'list');
q=lsb(a,Q);
for n=2:N+1
  %y(n)=x-a*y(n-1);
  yq(n)=qfix(x-qfix(a*yq(n-1),Q),Q);
  ydq(n)=qfix(x-qfix(a*ydq(n-1)+q*(rand(1,1)-0.5),Q)+q*(rand(1,1)-0.5),Q);
end
figure(1)
h=stem(0:N,yq,'-b');
set(h,'markersize',.5)
title('Limit-cycle oscillation')
zoom on, shg
%
figure(2)
h=stem(0:N,ydq,'-r');
set(h,'markersize',.5)
title('The effect of dither')
%