disp('Solving exercise 16.6 ...')
%Last edited: Dec. 9, 2007, IK

B=32; p=24; a11=0.5; a21=0.1;
global N_for_test_only
if isempty(N_for_test_only), Nx=2e3; else Nx=1.5*N_for_test_only; end
Ns=100; x=sin(1.5*2*pi*[1:Nx]'/Ns);
for rtype={'fix','float'}
%for rtype={'float','fix'}
  y=zeros(Nx,1); yq=y;
  rtype=rtype{1};
  F=1/0.4^2*(a11^2*1/(1-a11^2)+a21^2*1/(1-a21^2)-2*a11*a21/(1-a11*a21))
  if strcmp(rtype,'fix')
    disp('Fixed-point roundoff, B=32')
    Q=qstruct(struct('type','fixed-point','B',B,'fract',B-1,'ovf','c')); q=lsb(-1,Q);
    fprintf('q = %.4g = 2^%.f\n',q,log2(q))
    x=(1-q)*x;
    RMSth=3*q^2/12*F;
  elseif strcmp(rtype,'float')
    disp('Floating-point roundoff, p=24')
    Q=qstruct(struct('type','floating-point','p',p,'Emin',-126,'Emax',127));  
    RMSth=0.180*2^(-2*p)*1/2*(0.6^2+0.05^2+0.55^2+0.4^2+1)*F;
  else
    error('Unknown rtype')
  end
  qstructget(Q)
  RMSth
  for n=3:Nx
    y(n)=0.6*y(n-1)-0.05*y(n-2)+0.4*x(n);
    yq(n)=roundq(roundq(roundq(0.6*y(n-1),Q)-roundq(0.05*y(n-2),Q),Q)+...
      roundq(0.4*roundq(x(n),Q),Q),Q);
    if rem(n,50)==2, fprintf('.'), end %sign of life
    if rem(n,50*50)==1, disp(' '), end
  end
  plot((yq(150:end)-y(150:end))), shg
  disp(' ')
  RMSnu2=mean((yq(150:end)-y(150:end)).^2)
end
