function exercise_16_9
disp('Solving exercise 16.9 ...')

close all
global ovf_global
global resfiltq_sign_of_life
resfiltq_sign_of_life=1;

B=16; q=2^(-(B-1)); Qfix=qstruct('Qfix','B',B,'fb',B-2);
p=12; Qfloat=qstruct('Qfloat','p',p);
ord=3;

A=0.06; %0.06

for Q={Qfix,Qfloat}
  for N=[3,8]
    b=[0.7,0.19,-0.28,1];
    a=[1,-0.28,0.19,0.7];
    [wm,rm,zm]=tf2res(b,a,N); 
    %z2=exp(j*0.16*2*pi); [wm,rm,zm]=tf2res(b,a,[1,z2,conj(z2)]);
    [bm,am]=res2tf(wm,rm,zm);
    for f=[0.1,0.16]
      if iscell(Q), Q=Q{1}; end 
      for impl={'real','coupled','complex'}
        disp(Q.Type)
        impl=impl{1};
        fprintf(['Implementation: ',impl,', N = %.0f\n'],N)
        fprintf('A = %.3f, f = %.3f\n',A,f)
        ovf_global=[];
        %a=[1,-0.28,0.19,0.7]; b=[0.7,0.19,-0.28,1];
        Ntr=120;
        Nx=400+Ntr+2;
        x=A*sin(2*pi*f*[1:Nx]');
        y=filter(b,a,x);
        %impl='coupled'; %impl='real'; %impl='complex';
        [yr,dummy,Zmax]=resfiltq(wm,rm,zm,x,[],Q,struct('implementation',impl));
        SNR=10*log10(A^2/2/mean((yr(Ntr+3:end)-y(Ntr+3:end)).^2));
        fprintf('SNR: %.3f, Expminmax: (%.2f, %.2f)\n',SNR,Zmax(1),Zmax(2))
        Zmax; plot(yr), %hold on, plot(0,Nx],[1,1],':'), hold off
        set(gca,'xlim',[-100,Nx+100]), drawnow, shg
        %save
        %if any(ovf_global), warning('Overflow in exercise 16.9'), end
        fprintf('------------------------------\n')
      end
    end
  end
end
