disp('Solving exercise 18.1 ...')

close all
global N_for_test_only
if exist('N_for_test_only')&~isempty(N_for_test_only), N=N_for_test_only; else N=200; end
y=zeros(max(N,100),1); y(1)=0; 
y24=y; y32=y; y40=y; y48=y;
for p=[24,32,40,48]
  Q=qstruct(struct('p',p));
  eval(['ys=y',sprintf('%.0f',p),';']);
  for n=1:N-1
    %y(n+1)=\frac{1}{2}y(n)+\frac{1}{2}|y(n)|^{0.5}+0.1;
    y(n+1)=y(n)/2+abs(y(n))^(0.5)+0.1;
    ys(n+1)=qfloat(qfloat(ys(n)/2+qfloat(abs(ys(n))^(0.5),Q))+0.1,Q);
  end
  eval(['y',sprintf('%.0f',p),'=ys;']);
  eval(['var',sprintf('%.0f',p),'=std(ys(1:100)-y(1:100))^2']);
end
plot(y,'linewidth',.5)
xlabel('n'), title('y (double precision)')
hold off, zoom on, shg
figure(2)
plot(ys-y,'linewidth',.5)
xlabel('n'), title(sprintf('ys-y, p = %.0f',p))
hold off, zoom on, shg
figure(3)
semilogy([24,32,40,48],[var24,var32,var40,var48],'x')
coeff=[ones(4,1),[24,32,40,48]']\log10([var24,var32,var40,var48]');
hold on
semilogy([24,53],10.^(coeff(1)+coeff(2)*[24,53]),':')
hold off
set(gca,'xtick',[24,32,40,48,53],'xlim',[20,55],'ylim',[10^(-35),10^(-10)])
title('Variance vs. bit numbers')
grid on
shg

saveprobfig(1,['figp_20_1a.eps']) 
saveprobfig(2,['figp_20_1b.eps'])
saveprobfig(3,['figp_20_1c.eps'])
