disp('Solving exercise 20.1 ...')

close all
f1=1e3;
B=10; Nq=2^B;
N=4046;
A=3.5; Amax=5; phi=2*pi*rand(1,1);
for ii=[1,3,4]
  if any(ii==[1,4]), fs=3000*f1;
  elseif ii==3, fs=560*f1;
  end
  if ii==4, Ad=0.0049; else Ad=0; end
  t=[0:N-1]/fs;
  x=A*sin(2*pi*f1*t+phi);
  q=2*Amax/Nq;
  xq=q*round((x+Ad*2*rand(size(x)))/q);
  nu=xq-x;
  f=[0:N-1]/N*fs;
  figure(ii)
  plot(f,db(fft(nu)))
  set(gca,'ylim',[-35,10])
  ylabel('dB')
  titl=sprintf('Spectrum of the quantization error, fs = %3.0f f1',fs/f1);
  if Ad>0, titl=[titl,sprintf(', Ad = %.4f',Ad)]; end
  title(titl)
  if ii==1, fprintf('fs < %.2g f1\n',0.5*pi*A/q), end

  saveprobfig(ii,['figp_12_1',setstr('a'-1+ii),'.eps'])
end