if ~exist('q'), q=1; end,if ~exist('A'), A=4*q; end 
%disp('Solving exercise 4.10_1-2 ...')
%A=2*q/2;
%fprintf('\nUniform PDF, A = %.3gq\n',A/q)

format short e
if rem(A,q)==q/2
  N=round((A-q/2)/q);
  R2th=-2*q^2/12;
  xq2=q^2*2/(2*N+1)*sum([1:N].^2);
  xq2th=q^2*N*(N+1)/3;
  R2th=-2*q^2/12;
  xq4=q^4*2/(2*N+1)*sum([1:N].^4);
  xq4th=q^4*N*(N+1)*(3*N^2+3*N-1)/15;
  R4th=(-20*N^2-20*N+1)/60;
elseif rem(A,q)==0
  N=round(A/q);
  xq2=q^2*2/(2*N)*(sum([1:N].^2)-0.5*N^2);
  xq2th=q^2*(2*N^2+1)/6;
  R2th=q^2/12;
  xq4=q^4*2/(2*N)*(sum([1:N].^4)-0.5*N^4);
  xq4th=q^4*( (N+1)*(2*N+1)*(3*N^2+3*N-1)/30 - 15*N^3/30 );
  R4th=q^4*(40*N^2-21)/240;
else error(sprintf('A = %.4gq is not allowed',A))
end
S2=q^2/12;
R2=xq2-q^2/12-A^2/3;
R2pS2=R2/S2;
%
x2=A^2/3;
x4=A^4/5;
S4=1/2*q^2*xq2-7/240*q^4;
R4=xq4-S4-A^4/5;
%R4, S4
R4pS4=R4/S4;
%cas=2-rem(A,q),xq2,xq2th,xq4,xq4th
%R2,R2th,R4,R4th, pause
%
%disp('Monte Carlo')
Nx=1.5e6;
x=A*(2*(rand(Nx,1)-0.5));
figure(1)
hist(x,50)
%saveprobfig(2,'figp_4_11b.eps')
xq=q*round(x/q);
R2_MC=(mean(xq.^2)-q^2/12)-mean(x.^2);
R4_MC=mean(xq.^4)-(q^2/2*mean(xq.^2)-7/240*q^4)-mean(x.^4);

ds=dbstack;
if (length(ds)<2)|~strcmp(ds(2).name,'exercise_4_24')
  R2_S2_R2pS2_R2MC=[R2,S2,R2/S2,R2_MC]
  R4_S4_R4pS4_R4MC=[R4,S4,R4/S4,R4_MC]
end
format short