disp('Solving Exercise 4.6 ...')

close all

q=1; sigma=1; mu=q/4; N=1e6;
x=sigma*randn(N,1)+mu;
xq=q*round(x/q);
M1PQN=mu;
M2PQN=mu^2+sigma^2+q^2/12;
M3PQN=mu^3+3*mu*(sigma^2+q^2/12);
M4PQN=mu^4+3*sigma^4+6*(mu^2*sigma^2+mu^2*q^2/12+sigma^2*q^2/12)+q^4/80;

M1=mean(xq); sigmaM1=std(xq)/sqrt(N);
M2=mean(xq.^2); sigmaM2=std(xq.^2)/sqrt(N);
M3=mean(xq.^3); sigmaM3=std(xq.^3)/sqrt(N);
M4=mean(xq.^4); sigmaM4=std(xq.^4)/sqrt(N);

fprintf('M1 = (%.3g, %.3g), M1PQN = %.3g\n',M1-2*sigmaM1,M1+2*sigmaM1,M1PQN)
fprintf('M2 = (%.3g, %.3g), M2PQN = %.3g\n',M2-2*sigmaM2,M2+2*sigmaM2,M2PQN)
fprintf('M3 = (%.3g, %.3g), M3PQN = %.3g\n',M3-2*sigmaM3,M3+2*sigmaM3,M3PQN)
fprintf('M4 = (%.3g, %.3g), M4PQN = %.3g\n',M4-2*sigmaM4,M4+2*sigmaM4,M4PQN)
