disp('Solving exercise 6.4 ...')

figure(1)
subplot(2,1,1)
plot([-1,-.5,-.5,-.5,.5,.5,.5,1],[0,0,.5,0,0,.5,0,0],'linewidth',1.6)
set(gca,'xtick',[-.5:.5:.5],'xticklabel',{'-q/2','0','q/2'})
title('f(x'')')
subplot(2,1,2)
nu=sort([-1:0.01:1,-0.5-eps,0.5-eps,-0.5+eps,0.5+eps]);
fnu=zeros(size(nu));
ind=find(abs(nu)<=.5);
q=1;
fnu(ind)=1/log(4)*q./(abs(nu(ind))+.5);
plot(nu,fnu,'linewidth',1.6)
set(gca,'xtick',[-.5:.5:.5],'xticklabel',{'-q/2','0','q/2'})
title('f(\nu)')

saveprobfig(1,['figp_6_4a.eps']) 

q=1; s=q/2;
%s=0
muv=[0:0.001:2]*q;
%muv=[-5:0.01:5]*q;
Exnuv=zeros(size(muv));

l=[1:100];
dx=0.001; xi=0:dx:q/2;
ii=0; CF=zeros(size(l));
for li=l
  ii=ii+1;
  CF(ii)=(-1).^li/log(2)*sum(cos(2*pi*li/q*xi)./(xi+q/2)*dx);
end
dCF=zeros(size(CF));

ii=0;
for mu=muv
  ii=ii+1;
  Exnu=q/pi*sum(real(exp(j*l*2*pi/q*s).* ...
    (exp(j*l*2*pi/q*mu).*dCF + j*mu*exp(j*l*2*pi/q*mu).*CF)...
    .*(-1).^(l+1)./l));
  Exnu=Exnu-s*q/pi*sum(imag(exp(j*l*2*pi/q*s).*exp(j*l*2*pi/q*mu).*CF).*(-1).^l./l);
  Exnuv(ii)=Exnu;
  %Exnuv(ii)=Exnu/(mu-s)*pi;
end

figure(2)
plot(muv,Exnuv,'linewidth',1.6), grid
xlabel('\mu')
title('E\{x\cdot\nu\}  (s=q/2, q=1)')

saveprobfig(2,['figp_6_4b.eps']) 
