function edm(f1,f2)
%EDM Call editor, clear function edit function on path

%	Written by I. Kollar
%	Last modified: 18-Feb-1996, I. Kollar
if nargin<2, f2=''; end
if nargin<1, f1=''; end
c=computer;
if strcmp(c,'PCWIN'), isPC=1; else isPC=0; end
if isPC, delim='\'; elseif isunix, delim='/'; else delim=':'; end
if ~isempty(delim)
  ind=find(([f1,' ']=='/')|([f1,' ']=='\'));
  if ~isempty(ind), f1(ind)=setstr(delim*ones(size(ind))); end
  ind=find(([f2,' ']=='/')|([f2,' ']=='\'));
  if ~isempty(ind), f2(ind)=setstr(delim*ones(size(ind))); end
end
if ~isempty(f2)
  i2=max([find(f2==delim),0]); i22=min(find([f2,'.']=='.'));
  f2nam=f2(i2+1:i22-1); disp(['clear ',f2nam])
  clear(f2nam)
elseif ~isempty(f1)
  i1=max([find(f1==delim),0]); i11=min(find([f1,'.']=='.'));
  f1nam=f1(i1+1:i11-1); disp(['clear ',f1nam])
  clear(f1nam)
  f1=which(f1nam);
  if length(f1)==1, error(['''',f1nam,''' does not exist']), end
  pwdstr=pwd;
  if length(pwd)<length(f1)-length(f1nam)-3
    i=findstr(pwdstr,f1);
    if ~isempty(i), f1=f1(length(pwd)+2:length(f1)); end
  end
end
if ~isempty(f2)
  if exist(f2)==2, disp([f2,' exists!']), return, end
end
if isPC
  edstr=['ne ',f1,' ',f2,' ','&'];
  disp(['Executing  ',edstr,' ...'])
  disp(' ')
  dos(edstr);
elseif isunix
  edstr=['vi ',f1,' ',f2];
  disp(['Executing  ',edstr,' ...'])
  disp(' ')
  %unix(edstr);
  eval(['!',edstr]);
end
