function longtick(ax,form)
%LONGTICK Makes tick labels
%       Author(s): A. Potvin, 3-29-95
%       Copyright (c) 1985-95 by The MathWorks, Inc.
ni = nargin;
if ni==0,
   ax = gca;
end
if ni<2,
   form = '%1.5f';
end
str = '';
for i=get(ax,'YTick'),
   str = [str; sprintf(form,i)];
end
set(ax,'YTickLabels',str)
% end longtick
