disp('Solving problem 13.7 ...')

close all

p=8; 
%Emin=-126; Delta=2^Emin;
Delta=1;
q=pow2(-(p-1))*Delta;
sigma=25*Delta; mu=30*Delta;
%
M=8; dx=q/M;
x=[-3*sigma+dx/2:dx:3*sigma]; x=x+mu;
global N_for_test_only
if ~isempty('N_for_test_only'), x=[-3*sigma+dx/2:6*sigma/N_for_test_only/10:3*sigma]; end
fx=1/sqrt(2*pi)/sigma*exp(-(x-mu).^2/2/sigma^2);
[y,dcomp]=compress(x,Delta,'p');
%figure(1), plot(x,y), shg, figure(2), plot(x,dcomp), set(gca,'ylim',[0,1.1]), figure(2)
%
ylim=1.1*max(abs(y));
nlim=(1+4/M)*q/2;
%nFLlim=q/2*pow2(ceil(log2(3*sigma/Delta))-1);
nu=[-nlim+dx/2:dx:nlim]; fn=zeros(size(nu));
yvar=[-ylim+dx/2:dx:ylim]; fy=zeros(size(yvar));
E2nu=0; munu=0; P=0;
Enuy=0; Ey2=0; muy=0;
for ii=1:length(x)
  if ii==1, fprintf('ii = 1, '), end
  %
  [niifound,ind]=min(abs(yvar-y(ii)));
  fy(ind)=fy(ind)+fx(ii);
  nii=q*round(y(ii)/q)-y(ii);
  %
  [niifound,ind]=min(abs(nu-nii));
  fn(ind)=fn(ind)+fx(ii);
  %
  P=P+fx(ii)*dx;
  munu=munu+fx(ii)*dx*nii;
  E2nu=E2nu+fx(ii)*dx*nii^2;
  muy=muy+fx(ii)*dx*y(ii);
  Ey2=Ey2+fx(ii)*dx*y(ii)^2;
  Enuy=Enuy+fx(ii)*dx*nii*y(ii);
  %
  if rem(ii,1000)==0
    if (rem(ii,10000)>1000)|(rem(ii,10000)==0), fprintf(', '), end
    fprintf('%.0f',ii)
    if rem(ii,10000)==0, fprintf('\n'), end
  end
end %for ii
if rem(ii,10000)~=0, fprintf('\n'), end
ic2=0; niv=q/2*[-1-eps,-1+eps,1-eps,1+eps];
for ni=niv
  ic2=ic2+1; [dummy,ind]=min(abs(nu-ni));
  if rem(ic2,2)==1, fn=[fn,fn(max(ind-1,1))]; else fn=[fn,fn(min(ind+1,length(fn)))]; end
end
nu=[nu,niv];
[nu,nind]=sort(nu); fn=fn(nind);
qp2=q/2
%
ic=0;
for label='ab'
  ic=ic+1;
  figure(label-'a'+1)
  if (label-'a'+1)==1
    ylimplot=8;
    plot(yvar,fy), set(gca,'xlim',[-ylimplot,ylimplot],'ylim',[0,0.6]) %
    xlabel(sprintf('q = %.4g',q))
  else
    nlimplot=0.006;
    plot(nu,fn); set(gca,'xlim',[-nlimplot,nlimplot],'ylim',[0,200])
    xlabel(sprintf('q/2 = %.4g',q/2))
  end
  %ylimits=get(gca,'ylim'); ylimits(1)=0; set(gca,'ylim',ylimits)
  shg
  saveprobfig(label-'a'+1,['figp_13_7',label,'.eps'])
end %for label
fprintf('Ptot = %.2g\n',P)
fprintf('var{nu} = %.6g*q^2/12\n',(E2nu-munu^2)/(q^2/12))
fprintf('r_{nu,y} = %.2e\n',(Enuy-munu*muy)/sqrt(E2nu-munu^2)/sqrt(Ey2-muy^2));
