disp('Solving problem 13.7 ...')

%Works only in Matlab 7 or later 
ver=version;
if ver(1)>='7'
  a=single(1);
  sigma_x=single(0.01);
  N=10^7;
  p=24;
  
  sigma_av=sigma_x/sqrt(N)
  sigma_av_roundoff=1/N*sqrt((N+N*(N+1)*(2*N+1)/6+N^2)*0.180*2^(-2*p))
  av=single(0);
  for ii=1:N/1e5
    x=[av;a+sigma_x*single(randn(1e5,1))];
    av=sum(x);
  end
  err_av=(av/N)-a
  
  sigma_av_roundoff2=1/N*sqrt(N*(1^2+sigma_x^2)*0.180*2^(-2*p))
  av=single(0);
  for ii=1:N/1e5
    x=[a+sigma_x*single(randn(1e5,1))];
    for i2=1:length(x)
      av=av+(x(i2)-a);
    end
  end
  err_av2=av/N
else
  warning('Cannot run the M-file in this Matlab version')   
end
