disp('Solving problem 16.8 ...')

close all
%fixed-point
B=16; q=2^(-(B-1))
ord=3;
varnuout=4*ord*q^2/12
a=[1,-0.28,0.19,0.7]; b=[0.7,0.19,-0.28,1];

Ntr=120;
Nx=1e3+Ntr+2; 
A=1; x=A*sin(2*pi*0.1*[1:Nx]);
xAR=filter([1],a,x); y=filter(b,a,x);
plot(xAR), shg
MS=[...
  mean(x(Ntr+3:end).^2)
    mean(xAR(Ntr+3:end).^2)
    mean((x(Ntr+3:end)-a(2)*xAR(Ntr+2:end-1)).^2)
    mean((x(Ntr+3:end)-a(2)*xAR(Ntr+2:end-1)-a(3)*xAR(Ntr+1:end-2)).^2)
    %mean((x(Ntr+3:end)-a(2)*xAR(Ntr+2:end-1)-a(3)*xAR(Ntr+1:end-2)-a(4)*xAR(Ntr:end-3)).^2)
    mean((b(1)*xAR(Ntr+3:end)).^2)
    mean((b(1)*xAR(Ntr+3:end)+b(2)*xAR(Ntr+2:end-1)).^2)
    mean((b(1)*xAR(Ntr+3:end)+b(2)*xAR(Ntr+2:end-1)+b(3)*xAR(Ntr+1:end-2)).^2)
    %mean((b(1)*xAR(Ntr+3:end)+b(2)*xAR(Ntr+2:end-1)+b(3)*xAR(Ntr+1:end-2)+b(4)*xAR(Ntr:end-3)).^2)
    mean(y(Ntr+3:end).^2)
  ]
p=12;
MSout=0.180*2^(-2*p)*(MS(2)*(sum(a(2:4).^2)+sum(b(1:3).^2)) + sum(MS([3,4,6,7,8])))*A^2
MSoutdB=10*log10(MSout)
SNRout=10*log10(0.5)-MSoutdB

figure(1)
H_AR=tf([1],a,1), bode(H_AR), shg
h_AR=impulse(H_AR); samplARmax=sum(abs(h_AR))
saveprobfig(1,'figp_16_8.eps')
H=tf(b,a,1); %bode(H), shg
h=impulse(H); samplmax=sum(abs(h))
%h2sum=sum(h.^2)

SNR1fix=10*log10(0.5/9.3e-10)
SNRfloat=10*log10(0.5/4.3e-8)

[k,v]=tf2latc(b,a);
ylat=zeros(size(x));
w=zeros(3,1); sk=zeros(Nx,12);
for n=1:Nx
  f=x(n)-k(3)*w(3);
  sk(n,12)=f; sk(n,11)=-k(3)*w(3);
  ylat(n)=f*k(3)+w(3);
  sk(n,10)=ylat(n); sk(n,9)=f*k(3);
  f=f-k(2)*w(2);
  sk(n,8)=f; sk(n,7)=-k(2)*w(2);
  w(3)=f*k(2)+w(2);
  sk(n,6)=w(3); sk(n,5)=f*k(2);
  f=f-k(1)*w(1);
  sk(n,4)=f; sk(n,3)=-k(1)*w(1);
  w(2)=f*k(1)+w(1);
  sk(n,2)=w(2); sk(n,1)=f*k(1);
  w(1)=f;
end
MSlat=[mean(sk(Ntr:end,1:end).^2)]
MSoutlat=0.180*2^(-2*p)*sum(MSlat)
%MSoutlatdB=10*log10(MSoutlat), SNRoutlat=10*log10(0.5)-MSoutlatdB
