disp('Solving problem 20.5 ...')

close all
p=18;
S=2^(p); Erep=0;
n=1; Pnm1=1;
while Pnm1>0.00001
  n=n+1;
  Pnm1=Pnm1*(S-n+1)/S;
  Erep=Erep+(n-1)/S*Pnm1*n;
end %while
Lper=Erep/2; sqrtS=sqrt(S);
fprintf('Expected period length: %.0f, sqrt(N) ~ %.0f\n',Lper,sqrtS)
Q=qstruct(struct('p',p));
a=3.8; a=qfloat(a,Q);
y0=0.1; %initial value alg1: Np=271, alg2: Np=166, alg3: Np=108
%y0=.1111; %alg3: Np=379
y0q=qfloat(y0,Q);
fprintf('Init: '), num2bin(y0q,Q)
%
N=500; 
if exist('N_for_test_only'), N=N_for_test_only; end %during tests, make a short cycle only
yN=zeros(N,1); yN(1)=y0q;
%transient
for k=1:N-1
  str='y(k+1)=a*y(k)*(1-y(k))';
  yN(k+1)=qfloat(qfloat(a*yN(k),Q)*qfloat(1-yN(k),Q),Q);
  if k==1, disp(['Expression: ',str]), end
  pause(0) %allow ctrl/c
end
%
N=5*2^17; %660000
Nall = 2.25*2^17; %300000
if exist('N_for_test_only'), N=N_for_test_only; end %during tests, make a short cycle only
fprintf('N = %.0f\n',N)
yall=zeros(Nall,1);
iy=0; y=yN(end);
c0=clock; k=0;
while k<=N
  k=k+1;
  %str='y(k+1)=a*y(k)*(1-y(k))';
  yc=qfloat(a*y,Q)*qfloat(1-y,Q);
  ycq=qfloat(yc,Q);
  dither=lsb(ycq,Q)*(rand(1,1)-0.5);
  y=qfloat(yc+dither,Q);
  if ~any(find(y==yall(1:iy))), iy=iy+1; yall(iy)=y; end
  pause(0) %allow ctrl/c
  if (k==100)|(k==1000)|(rem(k,5000)==0)
    disp('Do not push ctrl/c')
    save problem_20_1_tmp.mat
    fprintf('k = %.0f, Ny = %.0f, %.1f%% of k, %.3f%% of Nall',k,iy,100*iy/k,100*iy/Nall)
    fprintf(',  run time: %.1f min, expected from now: %.1f min\n',...
      etime(clock,c0)/60,(N-k)*etime(clock,c0)/60/k)
    disp('Push ctrl/c now if you want')
  end
end
fprintf('N = %.0f, Ny = %.0f, %.1f%%\n',N,iy,100*iy/Nall)
