disp('Solving problem 21.9 ...')

close all
Q=qstruct(struct('type','fixed-point','B',10,'fb',5,'coding','two''s complement'));
qstructget(Q)
b=0.3; bq=roundq(b,Q);
B=1; A=[1 -b]; H=tf([B,0],A,1); set(H,'variable','z^-1');
B=1; Aq=[1 -bq]; Hq=tf([B,0],Aq,1); set(Hq,'variable','z^-1');
He=Hq-H;

N=1000;
x=randn(N,1); y=zeros(size(x)); yq=y; yqbq=y;

%(a)
y=filter(B,A,x);
for ii=1:length(yq)
  %yc(ii)=x(ii)+b*yc(max(ii-1,1));
  yq(ii)=x(ii)+roundq(b*yq(max(ii-1,1)),Q);
end
Pq=mean((yq(100:end)-y(100:end)).^2)

%(b)
ybq=filter(B,Aq,x);
Pbq=mean((ybq(100:end)-y(100:end)).^2)

%(c)
for ii=1:length(yqbq)
  yqbq(ii)=x(ii)+roundq(bq*yqbq(max(ii-1,1)),Q);
end
Pqbq=mean((yqbq(100:end)-y(100:end)).^2)
