%disp('Solving problem 4.10_1-2 ...')

q=1; if ~exist('A'), A=1.5*q; end 
%A=2*q/2;
%fprintf('\nUniform PDF, A = %.3gq\n',A/q)

format short e
if rem(A,q)==q/2
  N=round((A-q/2)/q);
  %R2=-2*q^2/12;
  xq2=q^2*2/(2*N+1)*sum([1:N].^2);
  R2=xq2-q^2/12-A^2/3;
  xq4=q^4*2/(2*N+1)*sum([1:N].^4);
  R4=xq4-(q^2/2*xq2-7/240*q^4)-A^4/5;
elseif rem(A,q)==0
  N=round(A/q);
  %R2=q^2/12;
  xq2=q^2*2/(2*N)*(sum([1:N].^2)-0.5*N^2);
  R2=xq2-q^2/12-A^2/3;
  xq4=q^4*2/(2*N)*(sum([1:N].^4)-0.5*N^4);
  R4=xq4-(q^2/2*xq2-7/240*q^4)-A^4/5;
else error(sprintf('A = %.4gq is not allowed',A))
end
S2=q^2/12;
R2pS2=R2/S2;
%
S4=1/2*q^2*(3/2*q^2)-7/240*q^4;
R4pS4=R4/S4;
%
%disp('Monte Carlo')
Nx=1.5e6;
x=A*(2*(rand(Nx,1)-0.5));
figure(1)
hist(x,50)
%saveprobfig(2,'figp_4_11b.eps')
xq=q*round(x/q);
R2_MC=(mean(xq.^2)-q^2/12)-mean(x.^2);
R4_MC=mean(xq.^4)-(q^2/2*mean(xq.^2)-7/240*q^4)-mean(x.^4);

ds=dbstack;
if (length(ds)<2)|~strcmp(ds(2).name,'problem_4_24')
  R2_S2_R2pS2_R2MC=[R2,S2,R2/S2,R2_MC]
  R4_S4_R4pS4_R4MC=[R4,S4,R4/S4,R4_MC]
end
format short