disp('Solving Problem 6.1...')

close all
sigma=1; %q=1;
T1=zeros(4,3); T2=zeros(4,2);
T3=zeros(4,2); T4=zeros(4,2);
indT=0;
for q=[2,1.5,1,0.5]*sigma
  indT=indT+1;
  for mu=[0,q/4]
    covxnu=0; Expnudev=0; covxpnu=0; Enu=0; covxxp=0; 
    for l=[1:50]
      u=l*2*pi/q;
      covxnu=covxnu+q/pi*(-sigma^2*u)*exp(-sigma^2*u^2/2)*(-1)^(l+1)/l*cos(u*mu);
      Expnudevmod=q/pi*mu*exp(-sigma^2*u^2/2)*(-1)^(l)/l*sin(u*mu)...
        +q/pi*(-sigma^2*u)*exp(-sigma^2*u^2/2)*(-1)^(l+1)/l*cos(u*mu)...
        +q^2/pi^2*exp(-sigma^2*u^2/2)*(-1)^(l)/l^2*cos(u*mu);
      Expnudev=Expnudev+Expnudevmod;
      Enu=Enu+q/pi*exp(-sigma^2*u^2/2)*(-1)^(l)/l*sin(u*mu);
      covxxp=covxxp+q/pi*(-sigma^2*u)*exp(-sigma^2*u^2/2)*(-1)^(l+1)/l*cos(u*mu);
    end
    covxpnudev=Expnudev-Enu*(mu+Enu);
    if mu==0
      T1(indT,1)=covxnu/sqrt(q^2/12)/sigma;
      T1(indT,2)=Expnudev/(q^2/12);
      T1(indT,3)=covxxp/sigma^2;
    else
      T2(indT,1)=(covxnu+mu*Enu)/sqrt(q^2/12)/sqrt(mu^2+sigma^2);
      T2(indT,2)=covxnu/sqrt(q^2/12)/sigma;
      T3(indT,1)=Expnudev/(q^2/12);
      T3(indT,2)=covxpnudev/(q^2/12);
      T4(indT,1)=(covxnu+mu*Enu)/(q^2/12);
      T4(indT,2)=(covxnu)/(q^2/12);
    end
  end %for mu
end %for q
format short e
T1, T2, T3, T4
format short
