disp('Solving problem 6.6 ...')

close all

contrun='r'; ptype='m';
A=.5; dist='u'; ord=2; mumax=2; mj='c';
save tmp.mat contrun ptype A dist ord mumax mj 
yesinpacceptdefsave=''; 
global yesinpacceptdef
yesinpacceptdefsave=yesinpacceptdef; yesinpacceptdef='yes';
pause off
figure(1)
qmoments('tmp.mat')
title('Covariance of x and \nu')
xlabel('\mu/q')
delete(findall(1,'string','cfcalc: a'))
saveprobfig(1,['figp_6_6a.eps'])

contrun='r'; ptype='m';
A=.5; dist='u'; ord=2; mumax=2; mj='r';
save tmp.mat contrun ptype A dist ord mumax mj 
yesinpacceptdefsave=''; 
global yesinpacceptdef
yesinpacceptdefsave=yesinpacceptdef; yesinpacceptdef='yes';
pause off
figure(11)
qmoments('tmp.mat')
title('Corr. coefficient of x and \nu')
xlabel('\mu/q'), ylabel('')
delete(findall(11,'string','cfcalc: a'))
saveprobfig(11,['figp_6_6a2.eps'])

ptype='a'; mumax=1; amax=5; mj='c';
save tmp.mat contrun ptype A dist ord mumax mj mumax amax
figure(2)
qmoments('tmp.mat')
delete(findall(2,'type','text'))
title('Minimum/maximum of cov\{x,\nu\}')
xlabel('A/q')
ylabel('Units: q^2')
saveprobfig(2,['figp_6_6b.eps'])

ptype='a'; mumax=1; amax=5; mj='r';
save tmp.mat contrun ptype A dist ord mumax mj mumax amax
figure(12)
qmoments('tmp.mat')
delete(findall(12,'type','text'))
title('Minimum/maximum of corr. coeff of x and \nu')
xlabel('A/q'), ylabel('')
ylabel('')
saveprobfig(12,['figp_6_6b2.eps'])

yesinpacceptdef=yesinpacceptdefsave;
