function disp(x)
%DISP  Display @qdata objects without printing object name.
%   DISP(X) displays the object, without printing the object name.  In
%   all other ways it is the same as leaving the semicolon off an
%   expression.
%
%   See also INT2STR, NUM2STR, SPRINTF, RATS, FORMAT.

% Written 2003,2004 by JUHASZ Laszlo
% Modified by Istvn Kollr, May 6, 2006

% argument check
error(nargchk(1,1,nargin))

dbs=dbstack;
if (length(dbs)>=2)&strcmp(dbs(2).file,'datatipinfo.m')
  fprintf(['      ',num2str(double(x)),'\n'])
end
nbx=num2bin(x); 
%ind=find(nbx==setstr(10)); if ~isempty(ind), nbx=[nbx(ind-1),'\n',nbx(ind+1:end)]; end
fprintf(['      ',nbx,'\n'])
