function val = get(s,prop_name)
%GET QData
% 	Valid properies are: 'name' , 'data'
%
if nargin<=1, prop_name=''; end
if isempty(prop_name)
  disp(s)
  qget(s.name)
  return
end

switch prop_name
  case 'name'
    val = s.name;
  case 'data'
    val = s.data;
  case 'bin'
    val=num2bin(s); 
    ind=[find(ismember(val,' .()')),find(val==10)]; val(ind)=[];
    if strcmp(val(1),'t')|strcmp(val(1),'o'), val(1)='1'; end
  otherwise
    try, 
      val=qget(s.name,prop_name);
    catch, error([prop_name ,' is not a valid QData property'])
    end
end
%
