function y = isempty(a)
%ISEMPTY       True for empty @qdata object.
%     ISEMPTY(X) returns 1 if X is an empty object and 0 otherwise. An
%     empty object has no elements, that is prod(size(X))==0.

if length(a)==0, y=1; return, end
y = all(isempty(a(:).data));
