function y = ldivide(a,b)
%LDIVIDE(.\)   Array divide of @qdata objects.
%     A.\B denotes element-by-element dividing.  A and B
%     must have the same dimensions unless one is a scalar.
%     A scalar can be multiplied into anything.
%     Either of X or Y can be also a double array.
%     C = LDIVIDE(A,B) is called for the syntax 'A .\ B' when A or B is an
%     object.
%
%     Copyright (C) 2004 by JUHASZ Laszlo and Rvsz Sndor
%
%     See also RDIVIDE, MLDIVIDE, MRDIVIDE.


y = rdivide(a,b);