function [f,e] = log2(X)
%LOG2  Same as log2 for double. e is always double.

if nargout<2, error('Not enough output arguments'), end
data=X.data; f=X;
[f1,e]=log2(data(1,:,:,:));
for ii=1:size(data,1)
  data(ii,:)=pow2(data(ii,:),-e);
end
f.data=data;