function out=compvect(xv1,xv2,code)
%GTVECT  Compare vectors of bfp numbers

error(nargchk(3,3,nargin))
if ~isstr(code), error('code is not a string'), end
out=[];
if size(xv1,2)>1
  for ix=1:size(x1,2)
    out=[out,compvect(xv1(:,ix),xv2(:,ix))];
  end
  return
else
  x1=xv1; x2=xv2;
  if isempty(x1)&isempty(x2), out=any(findstr(code,'=')); return
  elseif isempty(x1)|isempty(x2), out=[]; return
  elseif (size(x1,2)~=1)|(size(x2,2)~=1), error('An argument is not a column vector')
  end

  while length(x1)<length(x2), x1=[x1;0]; end
  while length(x1)>length(x2), x2=[x2;0]; end
  if isequal(x1,x2)
    if strcmp(code,'~='), out=0; return
    else out=any(findstr(code,'=')); return
    end
  else
    if strcmp(code,'=='), out=0; return
    elseif strcmp(code,'~='), out=1; return
    end
  end
  for ii=1:length(x1)
    s=sign(x2(ii)-x1(ii));
    if any(s) %not equal
      if strcmp(code,'<')|strcmp(code,'<='), out=isequal(s,1); return
      elseif strcmp(code,'>')|strcmp(code,'>='), out=isequal(s,-1); return
      elseif strcmp(code,'=='), out=0; return
      elseif strcmp(code,'~='), out=0; return
      else error(['code not allowed: ''',code,''''])
      end
    end
  end
end
error('Cannot decide')
