function y=reverseorder(a)
%REVERSEORDER   change the order of the input BFP
%    X must have 2 ^ N number


% generating quantizer property short-code for 'double'
persistent qcode
if ~isempty(a.name)
    qcode = qdspdemo('quantizers',a.name);
end
    

%   qcode = ['SEGNUM=[3];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[53];',...
%         'LEADINGBIT=''hidden'';FRACTION=[52];INVSIGNAL=''neglect+nan'';',...
%         'OVERFLOW=''inf'';OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
%         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
%         'EMAX=[1023];EMIN=[-1022];'];

eval(qcode);


orsiza = size(a.data);
% calculating the number of segments in 'a'
segna = orsiza(1);
% calculating the real size WITHOUT segments - the length of size is
% minimum 2 so the '2:end' expression is always correct.
orsiza = orsiza(2:end);
% convert to two dimension
a.data = reshape(a.data,[segna,prod(orsiza)]);
t = a.data;
%we only needs the data now, for a while
lenga = length(a);
loglenga = log2(lenga);
if(prod(orsiza)~=lenga)
    error('only vector can be reversed');
end
a = a.data;
for i = 0 : lenga-1;
    ireverse = fordit(i,loglenga);
t(:,i+1)=a(:,ireverse+1);
end



% generating output object
t = reshape(t,[SEGNUM,orsiza]);
y.name = NAME;
y.data = t;
y = class(y,'qdata');

return

%--------------------------------------------------------------------------
function mire_fordit = fordit(kit,bitszam)
if(bitszam==0) mire_fordit =0; return; end;
if(bitszam<0 | kit<0) error ('XXX'); end;
mire_fordit = 0;
if(kit==0)mire_fordit =0;return; end;
for bi = 1 : bitszam
     aa = bitget(kit,bitszam-bi+1);
     mire_fordit=bitset(mire_fordit,bi,aa);
end
return