function strout = segs2bin(data,obj)
%SEGS2BIN  Show contents of data segments.
%
%     str = segs2str(data,obj)
%
%'obj' is just an object to refer to the class deirectory if 'data' is a vector.

% Written by IK

if isa(data,'qdata'), obj=data; data=data.data; end
if (size(data,2)~=1)|(size(data,3)~=1)
  error('data is not a vector')
end
[f,e]=log2(data(1)); s=sign(data(1));
str=''; if ~isempty(obj.name), prec=qget(obj.name,'precision'); else prec=[]; end
for ii=1:length(data)
  sii=sign(data(ii)); dataii=abs(data(ii));
  [fii,eii]=log2(dataii);
  if ii>1 
    str=[str,sprintf('\n')];
    fii=pow2(fii,eii-e);
  end 
  if (s*sii==-1)|((s==0)&(sii~=0))
    warning('signs differ')
  end
  if sii>=0, str=[str,'+.']; else str=[str,'-.']; end
  for k=1:22
    if (rem(k,4)==1)&(k>1), str=[str,' ']; end
    if fii>=0.5
      str=[str,'1']; fii=fii-0.5;
    else
      str=[str,'0']; 
    end
    fii=2*fii;
    %if nargin>1
      prec=prec-1;
      if isequal(prec,0), str=[str,' | ']; end
    %end
  end %for k
  if ~isequal(fii,0), error('dataii is too long'), end
end
if nargout>0, strout=str;
else disp(str)
end