function err = check_coding(x,s)
%CHECK_CODING      Checker function for the 'coding' property

% Copyright (C) 2003, 2004 by JUHASZ Laszlo

err = '';
if strcmp(s.type,'fixed-point') & strcmp(x,'sign-mag')
   err = '''sign-mag'' isn''t available for type ''fixed-point''.';
   return
elseif strcmp(s.type,'floating-point') & (strcmp(x,'unsign') | strcmp(x,'ones-comp'))
   err = '''unsign'' and ''ones-comp'' isn''t available for type ''floating-point''.';
   return
end
