function err = check_emax(x,s)
%CHECK_EMAX        Checker function for the 'emax' property

% Copyright (C) 2003, 2004 by JUHASZ Laszlo

err = '';
if ~isempty(x) & strcmp(s.type,'fixed-point')
   err = 'must be empty when type is ''fixed-point''.';
   return
elseif isempty(x) & strcmp(s.type,'floating-point')
   err = 'mustn''t be empty when type is ''floating-point''.';
   return
else
   ma = def_emax(s);
   mi = def_emin(s);
   if x > ma
      err = sprintf('%s%s%s\n%s','can''t be greater than ',num2str(ma),...
         ' for the actual value of expcoding, expbits, ',...
         '      overflow, nansignal (and expbias).');
      return
   elseif x < mi
      err = sprintf('%s%s%s\n%s','can''t be smaller than ',num2str(mi),...
         ' for the actual value of expcoding, expbits, ',...
         '      leadingbit (and expbias).');
      return
   end
end
