function err = check_name(x,s)
%CHECK_NAME        Checker function for the 'name' property

% Copyright (C) 2003 by JUHASZ Laszlo

err = '';
if isempty(x)
   err = 'must be nonempty.';
   return
elseif length(x)>30
   err = 'maximum length is 30.';
   return
elseif ~isname(x)
   err = [x,' is not a proper MATLAB variable name'];
   return
end
