function y = def_expcoding(s)
%DEF_EXPCODING     Default generator function for the 'expcoding' property

% Copyright (C) 2003 by JUHASZ Laszlo

switch s.type
case 'fixed-point'
   y = '';
case 'floating-point'
   switch s.coding
   case 'twos-comp'
      y = 'twos-comp';
   otherwise
      y = 'biased';
   end
otherwise
   error('Internal error 1')
end
