function y = def_fraction(s)
%DEF_FRACTION      Default generator function for the 'fraction' property

% Copyright (C) 2003 by JUHASZ Laszlo

switch s.type
case 'fixed-point'
   y = 0;
case 'floating-point'
   switch s.leadingbit
   case 'hidden'
      y = s.precision-1;
   case 'shown'
      y = s.precision-2;
   otherwise
      error('Internal error 1')
   end
otherwise
   error('Internal error 2')
end
