function [ki,hiba] = q_sin_test
%Q_SIN_test

alpha = qdata(rand(1),'BigFP');
beta = qdata(rand(1),'BigFP');

X = sin(alpha+beta);
Y = sin(alpha)*cos(beta)+cos(alpha)*sin(beta);

HX = ulp(alpha+beta) ./ 2*abs(cos(alpha+beta)) + ulp(sin(alpha+beta));
HY = ulp(sin(alpha)) * abs(cos(beta)) + abs(sin(alpha)) * ulp(cos(beta)) ...
   + ulp(cos(alpha)) * abs(sin(beta)) + abs(cos(alpha)) * ulp(sin(beta)) ...
   + ulp(sin(alpha) * cos(beta)      + cos(alpha)      * sin(beta))./2;

MAX_HIBA = HX + HY;

Z = X-Y;
if(Z<MAX_HIBA) 
    ki = MAX_HIBA - Z;
    hiba = Z;
else
    ki= 0;
end

return
