function [ki hiba] = sin_teszt
%SIN_TESZT

disp('Test sin_teszt running ...')

alpha = rand(1);
beta = rand(1);

X = sin(alpha+beta);
Y = sin(alpha)*cos(beta)+cos(alpha)*sin(beta);

HX = ulp(alpha+beta) / 2*abs(cos(alpha+beta)) + ulp(sin(alpha+beta));
HY = ulp(sin(alpha)) * abs(cos(beta)) + abs(sin(alpha)) * ulp(cos(beta)) ...
   + ulp(cos(alpha)) * abs(sin(beta)) + abs(cos(alpha)) * ulp(sin(beta)) ...
   + ulp(sin(alpha) * cos(beta)      + cos(alpha)      * sin(beta))/2;

MAX_HIBA = HX + HY;

Z = X-Y;
if(Z<MAX_HIBA) 
    ki = MAX_HIBA - Z;
    hiba = Z;
else
    ki= 0;
end

return
