function test_num2bin_k
%TEST_NUM2BIN_K

qclear -all;

qmake('sajat4');
qset sajat4 precision 8 leadingbit shown fraction 7 expbias 0 treathalf 'toeven' expcoding 'biased' expbits 4 emax 11 emin 1 
qget

qmake('sajat5');
qset sajat5 precision 40 leadingbit shown fraction 39 expbias 0 treathalf 'toeven' expcoding 'biased' expbits 10  
qget


%%% SAJAT4:

%  Itt kell adnia warning-ot, mert van egyes a kvantl PRECISION  rtke
%  utn is:
qproba_1_s4=qdata('+(1)(.)0000 0100 0000 0000 0000 0000 0000 0000 0000 0000 0000 1000 0000 (*2^)1000 0000 110 [7d]','sajat4')  % Az elbb kapott binris string qdata objektumm alaktsa


%%% SAJAT5:

bin130_s5=num2bin(130,'double')    % A 130 decimlis szm, mint binris string

%  Itt nem kell adnia warning-ot, mert nincs egyes a kvantl PRECISION
%  rtke utn is:
q130_s5=qdata(bin130_s5,'sajat5')  % Az elbb kapott binris string qdata objektumm alaktsa

%%% BigFP:

qproba_2_string='+(1)(.)0000 0100 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0100 0000 0010 1 (*2^)1000 0000 110 [7d]'


%  Itt nem kell adnia warning-ot, mert nincs egyes a kvantl PRECISION
%  rtke utn is, mivel a kvantl 110 bites:
%qproba_2_bigfp=qdata(qproba_2_string,'BigFP')  % Az elbb kapott binris string qdata objektumm alaktsa

%  Itt kell adnia warning-ot, mert van egyes a kvantl PRECISION  rtke
%  utn is:
%qproba_2_s5=qdata(qproba_2_string,'sajat5')  % Az elbb kapott binris string qdata objektumm alaktsa
