function varargout=qdspdemo(varargin)
%QDSPDEMO  Demonstrate working of QDSP

%Call private functions and scripts
if (nargin>=1)
  if isstr(varargin{1})&strcmp(varargin{1},'quantizers')
    if nargout==0, feval(varargin{:});
    elseif nargout==1, out1=feval(varargin{:}); varargout={out1};
    elseif nargout==2, [out1,out2]=feval(varargin{:}); varargout={out1,out2};
    else error('Unrecognized call')
    end
    return
  end
end

qclear %remove quantizers
if nargin==0
  k=[]; 
  clc %clear command window
else
  k=varargin{1};
end
menupont = 1;

%menu
clc;
%------------------------------------------------------------
%disp(MENU)
%disp(' ');
%disp('1 - QDSP teszt')
%disp('2 - IIRD teszt')
%disp('3 - Mandelbrot teszt')
%disp('4 - QDSP bemutat demo')
%disp(' ');
%disp(' ');
%disp(' ');
%menupont = input(['Vlasszon:']);
%------------------------------------------------------------
while ~isequal(menupont,0)
  menuk = cell(1,4);
  menuk{2} = 'QDSP sine test';
  menuk{3} = 'FFTD test';
  %menuk{3} = 'FFTD test (temp. disabled)';
  menuk{4} = 'IIRD test';
  %menuk{4} = 'IIRD test (temp. disabled)';
  menuk{1} = 'QDSP  demonstration';
  h=findall(0,'type','figure','name','MENU'); delete(h)
    
  if nargin>0, menupont=k; end
  if isempty(k) %call without arg
    menupont = menu('QDSP DEMO',menuk); %get answer
    hb=[findobj(0,'string','FFTD test');findobj(0,'string','IIRD test')];
    set(hb,'enable','off')
  else
    menupont=k;
  end
  %menunek megfelel feladat vgrehajtsa:
  %menupont
  if menupont == 0, return; end; %biztonsg kedvrt
  if menupont == 2
    clc
    testqdsp('testqmake'); testqdsp('sin_test_main'); 
    menupont = 2;
  elseif menupont == 3
    %warning('Temporarily out of order')
    clc, testqdsp('fftd_test'); 
    menupont = 3; 
  elseif menupont == 4
    %warning('Temporarily out of order')
    clc, testqdsp('iird_test');
    menupont = 4; 
  elseif menupont == 1,
    clc, qdspdemo_learn; 
    menupont = 1; 
  elseif ~isempty(k), 
    menupont=0; 
  end
  if nargin==1, menupont=0; end
end %whike menupont
%