%FFT_EXAMPLES  Check given fft examples

clear;
close all;

f = 100;

% fix pontos, 16 bites, fb = 14, dither: off

Q16_d_off = qstruct('Name','Q16','B',16,'fb',14)
qstructget(Q16_d_off)
 
% fix pontos, 16 bites, fb = 14, dither: u1
 
Q16_d_u1 = qstruct('Name','Q16','B',16,'fb',14,'dither','on','tod','u1')
qstructget(Q16_d_u1)
 
% 4 bites fix pontos, dither: off
 
Q4_d_off = qstruct('Name','Q4','B',4,'fb',3)
qstructget(Q4_d_off)
 
 % 4 bites fix pontos, dither: u1
 
 Q4_d_u1 = qstruct('Name','Q4','B',4,'fb',3,'dither','on','tod','u1')
 qstructget(Q4_d_u1)
 
clear t1;
clear x1;
 
tt = 1;
 for i=0:0.0001:0.0256-0.0001
    t1(tt)=i;
     tt=tt+1;
 end
 
 for i=1:length(t1)
    x1(i)=sin(2*pi*f*t1(i));
 end
 
 figure;
 plot(t1,x1,'x');
 title('A 100 Hz-es szinuszjel');
 
  %%  x1 jelre, gpi fft:
  
  figure;
  X1_fft_gepi = fft(x1);
  plot(abs(X1_fft_gepi));
  
  % FFT: 4 bites fixpontos aritmetika, dither nlkl:
  
 runmod.exponent = 'block-float';
 
 X1_4bit_roundfft_d_off=roundfft(x1,Q4_d_off,runmod);
 
 figure;
 plot(abs(X1_4bit_roundfft_d_off.data));
 title('FFT: 4 bites fixpontos aritmetika, dither nlkl');

 
 % DFT: 4 bites fixpontos aritmetika, dither nlkl:
  
  X1_4bit_rounddft_d_off=rounddft(x1,Q4_d_off,runmod);
 
  figure;
  plot(abs(X1_4bit_rounddft_d_off.data));
  title('DFT: 4 bites fixpontos aritmetika, dither nlkl');
 
 % FFT: 4 bites fixpontos aritmetika, ditherrel:
 
 X1_4bit_roundfft_d_u1=roundfft(x1,Q4_d_u1,runmod);
 
 figure;
 plot(abs(X1_4bit_roundfft_d_u1.data));
 title('FFT: 4 bites fixpontos aritmetika, ditherrel');
 
 % DFT: 4 bites fixpontos aritmetika, ditherrel:

 X1_4bit_rounddft_d_u1=roundfft(x1,Q4_d_u1,runmod);
 
 figure;
 plot(abs(X1_4bit_rounddft_d_u1.data));
 title('DFT: 4 bites fixpontos aritmetika, ditherrel');
  
 