function test_tf2res(option)
%TEST_TF2RES

global resfiltq_sign_of_life
resfiltq_sign_of_life=1;

iiv=1:15;
%iiv=[3,5,9,11,12];
%iiv=3;
if (nargin==1)&isstr(option), iiv=str2num(option);
else iiv=option;
end
for ii=iiv
  if ii==1, num0=[1,1]; den0=[1,-1,0.8]; zm=[1,j,-1,-j];
  elseif ii==2, num0=[1,1]; den0=[1,-1,0.8]; zm=[];
  elseif ii==3, num0=[0,ones(1,8)/8]; den0=[1]; zm=[16];
  elseif ii==4, num0=[0,ones(1,8)/8]; den0=[1]; zm='opt';
  elseif ii==5, num0=[1,1]; den0=[1,-1,0.8]; zm=[16];
  elseif ii==6, num0=[0,1]; den0=[1,-1,0.8]; zm=[];
  elseif ii==7, den0=[1,-0.28,0.19,0.7]; num0=[0.7,0.19,-0.28,1]; zm=[];
  elseif ii==8, den0=[1,-0.28,0.19,0.7]; num0=[0.7,0.19,-0.28,1]; zm=[4];
  elseif ii==9, den0=[1,-0.28,0.19,0.7]; num0=[0.7,0.19,-0.28,1]; zm='opt';
  elseif ii==10, num0=[0,1]; den0=[1,-1,0.8]; zm='opt';
  elseif ii==11, num0=[0,1]; den0=[1,-1,0.8,.05,.1]; zm='opt';
  elseif ii==12, num0=[0,1]; den0=[1,-1,0.8,.05,.1]; zm='';
  elseif ii==13, num0=[0,1]; den0=[1,-1,0.8]; zm='opt';
  elseif ii==14, num0=[0,0,0,1]; den0=[1,-1,0.8]; zm='opt';
  elseif ii==15, num0=[0,0,0,0,0,1]; den0=[1,-1,0.8]; zm='opt';
  end
  figure(1),freqz(num0,den0,1024,'whole'), ylim=get(gca,'ylim');
  num0; den0; %pause(1)
  [wm,rm,zmr]=tf2res(num0,den0,zm);
  [num,den]=res2tf(wm,rm,zmr);
  %rnum=roots(num), rden=roots(den)
  %
  figure(2), freqz(num,den,1024,'whole'), set(gca,'ylim',ylim); grid on, drawnow
  if any(imag(rm)), rmstr='rm complex'; else rmstr='rm real'; end
  if all(abs(diff(diff(phase(zmr))))<100*eps), zmstr='zmr uniform'; else zmstr='zmr spec'; end 
  if isstr(zm)&strncmp(zm,'opt',3), zmstr=[zmstr,', opt']; end
  if any(abs(roots(den))>=1), zmstr=[zmstr,sprintf(', p<%.2f, den unstab',max(abs(roots(den0))))]; end
  fprintf(['ii=%.0f, N=%.f, ord=%.0f/%0.f, ',rmstr,', ',zmstr,'\n'],...
    ii,length(zmr),length(num0)-1,length(den0)-1)
  disp(num0),disp(den0)
  %fprintf('----------------\n')
  %
  if 1
    ic=0;
    for alg={'real','coupled','complex'}
      ic=ic+1;
      y=resfiltq(wm,rm,zmr,[0.5,zeros(1,499)],[],struct('algorithm',alg));
      H=2*fft(y);
      figure(1+2*ic)
      subplot(2,1,1), plot(20*log10(abs(H))), ylabel('dB'), 
      if ~ismember(ii,[8,10]), set(gca,'ylim',ylim); grid, end
      title(alg)
      subplot(2,1,2), plot(phase(H)/2/pi*360), ylabel('degrees'), grid on, drawnow, shg
      title(alg)
      figure(1+2*ic+1), plot(y)
      title(alg)
      %if strcmp(alg,'real'), save, end
    end %for alg
  end
  figure(2), figure(1)
  if ii<iiv(end), pause(2), end
end
%figure(4)