function exercise(ab)
disp('Solving exercise 15.7 ...')

close all
if nargin==0, ab=''; end

Q=qstruct('B',32,'fb',31);
Qinput=qstruct('double');
Qcos=qstruct('double');
N=256; q=lsb(Q);
global N_for_test_only
if ~isempty(N_for_test_only), N=8; end %make tests shorter

if any(findstr('a',ab)) 
  disp('No input quantization, no coefficients quantization')
  x=1/32*(rand(N,1)-0.5)*2; xq=roundq(x,Q);
  Xq=rounddft(xq,Q,struct('Qinput',Qinput,'Qcos',Qcos));
  X=fft(xq);
  %figure(1), plot([0:N-1],real(X),'b',[0:N-1],imag(X),'g')
  varXth=q^2/12*N
  varX=var(Xq-X,1)/2
  if any(ovfind), error('overflow'), end
end

if any(findstr('b',ab))
  disp('Input quantization and all roundoffs')
  Qinput=Q; Qcos=Q;
  x=1/32*(rand(N,1)-0.5)*2; xq=roundq(x,Q);
  [Xq,ovfind]=rounddft(xq,Q,struct('Qinput',Qinput,'Qcos',Qcos));
  X=fft(x);
  %figure(1), plot([0:N-1],real(X),'b',[0:N-1],imag(X),'g')
  varXth=q^2/12*N
  varX=var(Xq-X,1)/2
  if any(ovfind), error('overflow'), end
end