disp('Solving exercise 17.13 ...')

gain1mod=(5*10/2^(10))/0.005 / (5/7.07)
gain2mod=(5*10/2^8)/0.005 / (5/7.07)
range=7.07/55.2
clf
qfigset

set(gcf,'units','inches')
p=get(gcf,'position');
set(gcf,'position',[p(1),p(2),0.55*p(3:4)])
set(gcf,'paperposition',[p(1),p(2),0.55*p(3:4)])

T=0.1;
H=tf(0.2*poly([1,0.905,-0.5]),poly([1,0.905,0.5])+[0,0.2*conv([1,0.5],[0.00484,0.00468])],T);
H1=bode(H,0), Hm1=bode(H,pi/T)
Hm1h=0.2*2*1.905*(-0.5)/(2*(-1.5)*1.905+0.2*(-0.5)*(-0.00484+0.00468))
w=[0:500]/500*pi/T;
h=bode(H,w); h=permute(h,[3,1,2]);
f=w/(2*pi);
plot(f*T,h), grid
%plot(f,20*log10(h))
set(gca,'xlim',[0,0.5]), shg
ylabel('Transfer function'), 
xlabel('Normalized frequency')
set(gca,'box','off'),

if strcmp(qfigtype,'psfrag')
  psfname=[qfigsdir,['figp_19_13','.eps']];
  %saveprobfig(1,['figp_19_13','.eps'])
  %disp(['Preparing file ',psfname,' ...'])
  %print('-deps',psfname)
elseif strcmp(qfigtype,'styled')
  %everything is done
else %strcmp(qfigtype,'simple')
  %everything is done
end
