function exercise_21_11
disp('Solving exercise 21.11 ...')

close all
Qs=qstruct('single','Name','Single');
Qd=qstruct('double','Name','Double');
qstructget(Qd), qstructget(Qs)

global N_for_test_only
if ~exist('N_for_test_only')&~isempty(N-for_test_only), N=1000; else N=N_for_test_only; end
t=[1:N];
x=sin(2*pi*t/22);
y=zeros(size(x));

%(a)
y=nonlin(x,Qd,Qd);
ycq=nonlin(x,Qd,Qs);
Pcq=mean((ycq(100:end)-y(100:end)).^2)

%(b)
yq=nonlin(x,Qs,Qd);
Pq=mean((yq(100:end)-y(100:end)).^2)

%(c)
yqcq=nonlin(x,Qs,Qs);
Pqcq=mean((yqcq(100:end)-y(100:end)).^2)


function y=nonlin(x,Qm,Qc);
y=zeros(size(x));
%y=[];
for ii=1:length(y)
  if ii==1, xs2=0; else xs2=qfloat(3*xs,Qm); end
  if ii==1, ym1=0; ym2=0;
  elseif ii==2, ym1=y(ii-1); ym2=0;
  else ym1=y(ii-1); ym2=y(ii-2);
  end
  xs=qfloat(x(ii)^2,Qm);
  xs1=qfloat(qfloat(2.7,Qc)*xs,Qm);
  Num=qfloat(xs1-xs2,Qm);
  Den=qfloat(qfloat(qfloat(2.2,Qc)*qfloat(ym1^2,Qm),Qm)+0.1,Qm);
  y(ii)=qfloat(qfloat(Num/Den,Qm)+qfloat(qfloat(1/3,Qc)*qfloat(sqrt(abs(ym2)),Qm),Qm),Qm);
  if rem(ii,100)==0
    if ii==100, fprintf('Q: arith: %s, coeffs: %s, ii =',Qm.Name,Qc.Name), end, fprintf(' %.0f',ii)
  end
  if ii==length(y), disp(' '), end
end %for ii
%y=qfloat(qfloat(.1,Qc)*x,Qm);
