disp('Solving exercise 3.15 ...')

N=1e6;
x=rand(N,1)-0.5;
Q=100;
B=1; A=[-1,1-1/Q];
H=tf(B,A,1);
y=filter(B,A,x);

figure(1)
hist(x,100), shg
saveprobfig(1,['figp_3_13a.eps'])
M1x=mean(x)
M2x=mean(x.^2), varn=1/12

figure(2)
hist(y,100), shg
saveprobfig(2,['figp_3_13b.eps'])
M1y=mean(y)
M2y=mean(y.^2), varyth=Q^2/(2*Q-1)/12

if exist('hist3.m','file')
  figure(3)
  hist3([x(1:end-3),x(4:end)],[25,25])
  xlabel(sprintf('Delay = %.0f taps',3))
  saveprobfig(3,['figp_3_13c.eps'])
else
  warning('Figure 3.15c is generated using the hist3 function of the statistics toolbox')
end

figure(4)
R=xcorr(x,'unbiased'); Nc=(length(R)+1)/2;
plot(R(Nc+[-500:500]))
title('Autocorrelation function of x')
xlabel(sprintf('Delay = %.0f taps',3))
saveprobfig(4,['figp_3_13d.eps'])

if exist('hist3.m','file')
  figure(5)
  hist3([y(1:end-3),y(4:end)],[25,25])
  xlabel(sprintf('Delay = %.0f taps',3))
  saveprobfig(5,['figp_3_13e.eps'])
else
  warning('Figure 3.15e is generated using the hist3 function of the Statistics Toolbox')
end

figure(6)
R=xcorr(y,'unbiased'); Nc=(length(R)+1)/2;
plot(R(Nc+[-500:500]))
title('Autocorrelation function of y')
xlabel(sprintf('Delay = %.0f taps',3))
saveprobfig(6,['figp_3_13f.eps'])

