ds=dbstack;
if ~(length(ds)>1)|~strcmp(ds(2).file,'exercise_4_26.m')
disp('Solving exercise 4.10 ...')
end

fprintf('\nTriangular PDF\n')
figure(1)
plot([-3,-2,0,2,3],[0,0,1,0,0],'linewidth',1.7)
hold on
for ii=-2.5:2.5
plot([ii,ii],get(gca,'ylim'),':')
end
for ii=0.25:0.25:0.75
plot(get(gca,'xlim'),[ii,ii],':')
end
hold off
shg
saveprobfig(1,'figp_4_10a.eps')

Nx=1e6; q=1; A=2*q;
R4=21/240*q^4;
x=A*(rand(Nx,1)-0.5)+A*(rand(Nx,1)-0.5);
figure(2)
hist(x,50)
saveprobfig(2,'figp_4_10b.eps')
xq=q*round(x/q);
%R2_MC=(mean(xq.^2)-q^2/12)-mean(x.^2)
R4_MC=mean(xq.^4)-(q^2/2*mean(xq.^2)-7/240*q^4)-mean(x.^4);

ds=dbstack;
if (length(ds)<2)|~strcmp(ds(2).name,'exercise_4_24')
  S4=1/2*q^2*3/4*q^2-7/240*q^4;
  R4pS4=R4/S4;
  R4_S4_R4pS4_R4MC=[R4,S4,R4/S4,R4_MC]
end
