disp('Solving exercise 4.26 ...')

close all

disp('Triangular PDF')
l=1:100; q=1;
exercise_4_10, R4tr=R4; R4_MCtr=R4_MC;
%R4_CF = 4*q*sum((-1).^l./(l*pi).*dddPhi(lPsi))...
%  +6*q^2*sum((-1).^(l+1)./(l*pi).^2.*ddPhi(Psi))
dPhi=zeros(size(l));
ddPhi=2*(q/(2*pi)*((-1).^l)./l).^2;
dddPhi=6*(q^2/(2*pi^2).*(-1).^(l+1)./l.^2).*(q/(2*pi)*((-1).^l)./l);
R4_CFtr = 4*q*sum((-1).^l./(l*pi).*dddPhi)...
  +6*q^2*sum((-1).^(l+1)./(l*pi).^2.*ddPhi);
ord=4; mtype='s'; ptype='m'; contrun='n'; dist='t'; mumax=0;
mj='s'; L=100;
save tmp.mat contrun ptype dist ord mumax mj mtype A L
yesinpacceptdefsave='';
global yesinpacceptdef
yesinpacceptdefsave=yesinpacceptdef; yesinpacceptdef='yes';
pause off
R4_qmom_tr=qmoments('tmp.mat');
yesinpacceptdef=yesinpacceptdefsave;

disp('Uniform PDF')
q=1; N=2;
if N<1, error('N is smaller than 1'), end
for A=[2*N*q/2,(2*N+1)*q/2];
  if rem(A,q)==q/2, exercise_4_11, R2uN5=R2; R2_MCuN5=R2_MC; R4uN5=R4; R4_MCuN5=R4_MC;
  elseif rem(A,q)==0, exercise_4_12, R2uN=R2; R2_MCuN=R2_MC; R4uN=R4; R4_MCuN=R4_MC;
  else error(sprintf('A = %.4gq is not allowed',A))
  end
  L=10000; l=1:L;
  R2=-2*q^2/12;
  %R2_CF = 2*q/pi*sum(dPhi(lPsi).*(-1).^(l+1)./l)
  dPhi=A*(-1).^(2*A/q*l)./((A/q)*l*2*pi);
  R2_CF = 2*q/pi*sum(dPhi.*((-1).^(l+1))./l);
  %
  ddPhi=(-2)*A^2*(-1).^(2*A/q*l)./(A/q*2*pi)^2 ./(l.^2);
  dddPhi= A^3*((-1).^(2*A/q*l+1)./(l*A/q*2*pi)+(6).*(-1).^(2*A/q*l)./(l*A/q*2*pi).^3);
  R4_CF = -2*q/pi*sum(dPhi.*((-1).^(l+1))./l)*q^2/2 ...
    +4*q*sum(dddPhi.*((-1).^l)./(l*pi)) ...
    +6*q^2*sum(ddPhi.*((-1).^(l+1))./((l*pi).^2)) ...
    +q^3.*sum(dPhi.*(((-1).^(l+1))./(l*pi)-6*((-1).^(l+1))./((l*pi).^3)));
  for ord=[2,4]
    mtype='s'; ptype='m'; contrun='n'; dist='u'; mumax=0;
    mj='s';
    save tmp.mat contrun ptype dist ord mumax mj mtype A L
    yesinpacceptdefsave='';
    global yesinpacceptdef
    yesinpacceptdefsave=yesinpacceptdef; yesinpacceptdef='yes';
    pause off
    if ord==2, R2_qmom=qmoments('tmp.mat'); else R4_qmom=qmoments('tmp.mat'); end
    yesinpacceptdef=yesinpacceptdefsave;
  end
  if rem(A,q)==q/2, R2_CFuN5 = R2_CF; R4_CFuN5 = R4_CF; AN5=A; R2_qmom_N5u=R2_qmom; R4_qmom_N5u=R4_qmom;
  elseif rem(A,q)==0, R2_CFuN = R2_CF; R4_CFuN = R4_CF; AN=A; R2_qmom_Nu=R2_qmom; R4_qmom_Nu=R4_qmom;
  else error(sprintf('A = %.4gq is not allowed',A))
  end
end %for A

disp('''House'' PDF')
q=1; A=2*q;
alpha=1; %House
%alpha=10^30; %triangular
%alpha=0; %uniform
B=1/(2*A+alpha*A);
exercise_4_11, R2h=R2; R2_MCh=R2_MC; R4h=R4; R4_MCh=R4_MC;
L=1000; l=1:L; 
R2=2*A*B*q^2/12;
%R2_CF = 2*q/pi*sum(dPhi(lPsi).*(-1).^(l+1)./l)
dPhi=(2*A*B*A/(4*pi)./l);
R2_CFh = 2*q/pi*sum(dPhi.*((-1).^(l+1))./l);
%
%R4h=2*A*B*139*A^4/3840 + alpha*A*B*21*A^4/3840;
ddPhi=2*A*B*(-2)*A^2/(4*pi)^2 ./(l.^2) ...
  +alpha*A*B*2*(A/2)^2/(2*pi)^2 ./(l.^2);
dddPhi=  2*A*B* A^3*((-1)./(A/q*l*2*pi)+(6)./(l*4*pi).^3)...
  +alpha *A*B * (A/2)^3*(-12)./(l*2*pi).^3;
R4_CFh = -2*q/pi*sum(dPhi.*(-1).^(l+1)./l)*q^2/2 ...
  +4*q*sum(dddPhi.*(-1).^l./(l*pi)) ...
  +6*q^2*sum(ddPhi.*(-1).^(l+1)./(l*pi).^2) ...
  +q^3.*sum(dPhi.*((-1).^(l+1)./(l*pi)-6*(-1).^(l+1)./(l*pi).^3));
for ord=[2,4]
  mtype='s'; ptype='m'; contrun='n'; dist='h'; mumax=0;
  mj='s'; alpha_house=alpha;
  save tmp.mat contrun ptype dist ord mumax mj mtype A alpha_house L
  yesinpacceptdefsave='';
  global yesinpacceptdef
  yesinpacceptdefsave=yesinpacceptdef; yesinpacceptdef='yes';
  pause off
  if ord==2, R2_qmomh=qmoments('tmp.mat'); else R4_qmomh=qmoments('tmp.mat'); end
  yesinpacceptdef=yesinpacceptdefsave;
end

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
fprintf('Results of CF-based series summation:\n')
fprintf('\nTriangular PDF, A = %.3gq\n',A/q)
R4_R4MC_R4CF_R4qmom_triang=[R4tr,R4_MCtr,R4_CFtr,R4_qmom_tr]
fprintf('\nUniform PDF, A = %.3gq\n',AN5/q)
R2_R2MC_R2CF_R2qmom_unifN5=[R2uN5,R2_MCuN5,R2_CFuN5,R2_qmom_N5u]
R4_R4MC_R4CF_R4qmom_unifN5=[R4uN5,R4_MCuN5,R4_CFuN5,R4_qmom_N5u]
fprintf('\nUniform PDF, A = %.3gq\n',A/q)
R2_R2MC_R2CF_R2qmom_unifN=[R2uN,R2_MCuN,R2_CFuN,R2_qmom_Nu]
R4_R4MC_R4CF_R4qmom_unifN=[R4uN,R4_MCuN,R4_CFuN,R4_qmom_Nu]
fprintf('\n"House" PDF, alpha=%.2g\n',alpha)
R2_R2MC_R2CF_R2qmom_house=[R2h,R2_MCh,R2_CFh,R2_qmomh]
R4_R4MC_R4CF_R4qmom_house=[R4h,R4_MCh,R4_CFh,R4_qmomh]
