disp('Solving exercise 4.4 ...')

close all
dx=.01; xv=[-5:dx:5];
sigma=1; q=1;
%F(x)=erf(x/sqrt(2))/2+.5;
fx=(erf(xv+.5/sqrt(2))/2+.5)-(erf(xv-.5/sqrt(2))/2+.5);

figure(1)
plot(xv,fx);
title('f_{x+n}(x)');
saveprobfig(1,'figp_4_4a.eps')

figure(2)
plot(xv,fx)
fx2=zeros(size(fx));
for ii=-5:5
  [dummy,ind]=min(abs(ii-xv));
  fxii=fx(ind);
  s=fxii*sinc((xv-ii));
  hold on
  plot(xv,s);
  fx2=fx2+s;
end
hold off
title('sinc functions');
saveprobfig(2,'figp_4_4b.eps')

figure(3)
plot(xv,fx,xv,fx2);
title('Interpolated and original PDF');
saveprobfig(3,'figp_4_4c.eps')
