disp('Solving exercise 6.3 ...')

figure(1)
subplot(2,1,1)
plot([-1,-.5,-.5,-.5,.5,.5,.5,1],[0,0,.5,0,0,.5,0,0],'linewidth',1.6)
set(gca,'xtick',[-.5:.5:.5],'xticklabel',{'-q/2','0','q/2'})
title('f(x'')')
subplot(2,1,2)
plot([-1,-.25,-.25,-.25,.25,.25,.25,1],[0,0,.5,0,0,.5,0,0],'linewidth',1.6)
set(gca,'xtick',[-.5:.5:.5],'xticklabel',{'-q/2','0','q/2'})
title('f(\nu)')

saveprobfig(1,['figp_6_3a.eps']) 

q=1; s=q/2; 
%s=0
muv=[0:0.001:2]*q;
%muv=[-5:0.01:5]*q;
Exnuv=zeros(size(muv));

l=[1:1000];
CF=(j.^(l)+(-j).^(l))/4;
%dCF=-3q/16*sin(3q*l*pi/2)-3q/16*sin(q*l*pi/2)
%dCF=-3/16*(sin(3*l*pi/2)+sin(l*pi/2));
dCF=zeros(size(CF));

ii=0;
for mu=muv
  ii=ii+1;
  Exnu=q/pi*sum(real(exp(j*l*2*pi/q*s).* ...
    (exp(j*l*2*pi/q*mu).*dCF + j*mu*exp(j*l*2*pi/q*mu).*CF)...
    .*(-1).^(l+1)./l));
  Exnu=Exnu-s*q/pi*sum(imag(exp(j*l*2*pi/q*s).*exp(j*l*2*pi/q*mu).*CF).*(-1).^l./l);
  Exnuv(ii)=Exnu;
  %Exnuv(ii)=Exnu/(mu-s)*pi;
end

figure(2)
plot(muv,Exnuv,'linewidth',1.6), grid
set(gca,'ylim',0.3*[-1,1])
xlabel('\mu')
title('E\{x\cdot\nu\}  (s=q/2, q=1)')

saveprobfig(2,['figp_6_3b.eps']) 
