%ACCTEST Try to determine accumulator precision, based on scalar product

fprintf(['Platform: ',computer,', version: ',version])
if ~isieee, fprintf(', non-'), else fprintf(', '), end
fprintf('IEEE machine')
fprintf('\n')
fprintf('eps = %.4g, 2^%.0f\n',eps,log2(eps))
teststrsave='';
for ii=1:10
  if ii==1, teststr='1+eps/2+eps/2-1';
  elseif ii==2, teststr='1+(eps/2+eps/2)-1';
  elseif ii==3, teststr='1+(eps/2+eps/pow2(1,11))-1';
  elseif ii==4, teststr='1+(eps/2+eps/pow2(1,12))-1';
  elseif ii==5, teststr='1+(eps/2+eps^2/2)-1';
  elseif ii==6, teststr='1+(eps/2+eps^2/4)-1';
  elseif ii==7, teststr='[1 , 1 , 1] * [1 ; eps/2 ; eps/4] - 1';
  elseif ii==8, teststr='[1 , 1 , 1] * [1 ; eps/2 ; eps^2] - 1';
  elseif ii==9, teststr='[1 , 1 , 1] * [1 ; eps/2 ; pow2(1,-105)] - 1';
  elseif ii==10, teststr='[1 , 1 , 1] * [1 ; eps/2 ; pow2(1,-106)] - 1';
  end
  fprintf(['Case %.0f, ',teststr,' = %.6g'],ii,eval(teststr))
  if eval(teststr)~=0, fprintf(',  %.0f * eps',eval(teststr)/eps), end
  fprintf('\n')
  if strcmp(teststr,teststrsave), error('Test string did not change'), end
  teststrsave=teststr;
end %for
%
%End of acctest
