%CERI2

echo on
load ceri.mat
%
%Test of scaling follows...
i=0; NaNv=NaN; dsc=1;
%dsc=10; %delayscale
for sc=[1,100]
  i=i+1;
  rfile=sprintf('sctest%.0f.rep',i);
  [pvi,fit,Cp,CR]=elis([fv,Xm/sc,Ym/sc],vdat/sc^2,...
           ['s'+0,nord,dord],'v',['s','f',0],[],pv,rfile);
  fprintf(rfile,'Scale factor = %.4g\n',sc)
  eval(sprintf('Cp%.0f=Cp;',i))
  eval(sprintf('CR%.0f=CR;',i))
end
%
echo off
if isunix
  %!diff sctest1.rep sctest2.rep > tmp
  !grep '1 s' sctest1.rep > tmp
  !grep '1 s' sctest2.rep >> tmp
  type tmp
elseif exist('diffreps.m')
  diffreps
else
  type sctest1.rep
  type sctest2.rep
end
%[diag(Cp1),diag(Cp2),diag(Cp1)-diag(Cp2)]
%[diag(CR1),diag(CR2),diag(CR1)-diag(CR2)]
do=nord+dord+3;
fprintf('CR: %.3e, %.3e, diff: %.3e\n',...
     CR1(do,do),CR2(do,do),CR1(do,do)-CR2(do,do))
fprintf('Cp: %.3e, %.3e, diff: %.3e\n',...
     Cp1(do,do),Cp2(do,do),Cp1(do,do)-Cp2(do,do))
%
%End of ceri
