function rstpv=idmodrst(pv)
%IDMODRST Restore class of idmodel after load - bypass Matlab bug

if isa(pv,'idmodel'), rstpv=pv; return, end
if ~isstruct(pv)&~isa(pv,'idmodel'), error('pv cannot be made idmodel'), end
level=0;
if isfield(pv,'type')&strcmp(pv.type,'fdident'), pvi=pv; level=1;
else fn=fieldnames(pv);
  for ii=1:length(fn)
    if eval(['isfield(pv.',fn{ii},',''type'')'])
      if eval(['isa(pv.',fn{ii},',''idmodel'')']), rstpv=pv; return, end
      if eval(['strcmp(pv.',fn{ii},'.type,''fdident'')'])
        pvind=ii; eval(['pvi=pv.',fn{ii},';']), level=2;
      end
    end    
  end
end
if isfield(pvi,'delays'), delays=pvi.delays; else delays=[]; end
if isfield(pvi,'freqvect'), fv=pvi.freqvect; else fv=[]; end
if isfield(pvi,'ntr'), ntr=pvi.ntr; else ntr=[]; end
rstpv=fdmodel(pvi.variable,pvi.num,pvi.denom,delays,pvi.fs,[],[],ntr,[],[],[],fv);
disp(['Warning! idmodel has been restored by idmodrst.'])
%
if isfield(pvi,'name'), set(rstpv,'name',pvi.name','noconsistency'); end
if isfield(pvi,'notes'), set(rstpv,'notes',pvi.notes','noconsistency'); end
if isfield(pvi,'history'), set(rstpv,'history',pvi.history','noconsistency'); end
if isfield(pvi,'userdata'), set(rstpv,'userdata',pvi.userdata','noconsistency'); end
if isfield(pvi,'fitinfo'), set(rstpv,'fitinfo',pvi.fitinfo','noconsistency'); end
if isfield(pvi,'chnames'), set(rstpv,'chnames',pvi.chnames','noconsistency'); end
if isfield(pvi,'chtypes'), set(rstpv,'chtypes',pvi.chtypes','noconsistency'); end
if isfield(pvi,'fixedpars'), set(rstpv,'fixedpars',pvi.fixedpars','noconsistency'); end
if isfield(pvi,'costvect'), set(rstpv,'costvect',pvi.costvect','noconsistency'); end
if isfield(pvi,'J'), set(rstpv,'J',pvi.J','noconsistency'); end
if isfield(pvi,'Znum'), set(rstpv,'Znum',pvi.Znum','noconsistency'); end
if isfield(pvi,'Zdenom'), set(rstpv,'Zdenom',pvi.Zdenom','noconsistency'); end
if isfield(pvi,'Zntr'), set(rstpv,'Zntr',pvi.Zntr','noconsistency'); end
if isfield(pvi,'units'), set(rstpv,'units',pvi.units','noconsistency'); end
if isfield(pvi,'covariance'), set(rstpv,'covariance',pvi.covariance','noconsistency'); end
set(rstpv,'type',rstpv.type)
if level==2
  pvsave=rstpv; rstpv=pv;
  eval(['rstpv.',fn{pvind},'=pvsave;'])
end
%
%End