function maxv=maxval();
%MAXVAL	Maximal number on this computer.
%	For use with Matlab 3.5 or earlier versions. Substituted by realmin
%	in Matlab 4.0.

%	Copyright (c) I. Kollar, 1990-93
%	Copyright (c) Vrije Universiteit Brussel, Dienst ELEC, 1990-93
%	All rights reserved.
%	Last modified: 27-Mar-1993
%
if exist('size')==5 %Matlab 4.0
  maxv=realmax;
  disp('WARNING! Usage of maxval is obsolete, please use realmax instead.')
else
  if strcmp(computer,setstr('pc'-32))|...
	strcmp(computer,setstr('pcat'-32))|...
	strcmp(computer,[setstr('pc'-32),'386'])|...
	strcmp(computer,setstr('at'-32))|...
	strcmp(computer,'386')
    maxv=1e308;
  elseif strcmp(computer,setstr('mac'-32))|...
	strcmp(computer,[setstr('mac'-32),'2'])|...
	strcmp(computer,setstr('macii'-32))
    maxv=1e308;
  else
    maxv=1;
  end
  while (2*maxv<inf)&(2*maxv>maxv), maxv=maxv*2; end
  dev=.5;
  while 1+dev>1
    if maxv*(1+dev)<inf, maxv=maxv*(1+dev); end
    dev=dev/1.9;
  end
end
%%%%%%%%%%%%%%%%%%%%%%%% end of maxval %%%%%%%%%%%%%%%%%%%%%%%%