disp('Solving problem 10.4 ...')

close all
N=1024; tauv=[0:N];
L=1000; l2=[1:L];
q=1; A=15*q;
R_xnu=zeros(size(tauv));
ii=0;
for tau=tauv
  ii=ii+1;
  R_xnu(ii)=R_xnu(ii)+q/pi*sum( ...
    -1/2*(besselj(0,A*l2*2*pi/q)+besselj(2,A*l2*2*pi/q)).*((A^2)*(l2*2*pi/q)*cos(tau/N*2*pi)) ...
    .*(-1).^(l2+1)./l2);
end
disp(' ')
figure(1)
clf
plot([-fliplr(tauv(2:N)),tauv],[fliplr(R_xnu(2:N)),R_xnu]), %set(gca,'xlim',[-10,10])
saveprobfig(1,['figp_10_4.eps'])

%Monte Carlo
figure(2)
x=A*sin(2*pi*tauv(1:end-1)/N)
x=[x,x,x,x];
plot(x), shg
nu=q*round(x/q)-x;
plot(xcorr(x,nu,'unbiased')), shg
