disp('Solving problem 11.4 ...')

close all
global N_for_test_only
if ~isempty(N_for_test_only), Nx=N_for_test_only; else Nx=0.5e6; end

plotno=0;
mtypes='nns'; ordn=0; q=1;
for ord=[1,2,2]
  ordn=ordn+1; mtype=mtypes(ordn);
  for ptype='ma'
    plotno=plotno+1;
    figure(plotno)
    sigm=0.5; dist='g'; 
    if ordn<3, mumax=1; else mumax=5; end 
    amax=.8;
    muv=[0:0.01:mumax];
    if strcmp(ptype,'m'), sigmv=sigm; 
    else sigmv=0.01:0.01:amax;
    end
    xc=floor(-4*max(sigmv)+min(muv)):ceil(4*max(sigmv)+max(muv));
    E=zeros(2,length(sigmv)); is=0;
    for sigm=sigmv
      Emu=zeros(size(muv));
      is=is+1; 
      if is==2, c0=clock; 
      elseif is==3, t=etime(clock,c0);
        fprintf('Expected execution time: %.1f min\n',(length(sigmv)-2)*t/60)
      end
      if (length(sigmv)>1)&(is==3), fprintf('.'), end %sign of life
      x=sigm*randn(Nx,1); 
      mui=0;
      for mu=muv
        mui=mui+1;
        xq=q*round(x+mu);
        if strcmp(mtype,'n')&isequal(ord,1)
          Emu(mui)=Emu(mui)+mean(xq-x-mu);
        elseif strcmp(mtype,'n')&isequal(ord,2)
          Emu(mui)=Emu(mui)+mean((xq-x-mu).^2)-q^2/12;
        elseif strcmp(mtype,'s')&isequal(ord,2)
          Emu(mui)=Emu(mui)+mean(xq.^2)-sigm^2-mu^2-q^2/12;
        else
          error('Type not known')
        end
      end %for mu
      if strcmp(ptype,'a')
        E(1,is)=max(Emu);
        E(2,is)=min(Emu);
      end
    end %for sigm
    if strcmp(ptype,'m')
      plot(muv,Emu)
    else %amplitude
      semilogy(sigmv,E(1,:))
      disp(' ')
    end
    if strcmp(mtype,'n')
      if ord==1, title(['E\{\nu\}'])
      else title(['Deviation of E\{\nu^',num2str(ord),'\} from q^2/12'])
      end
    elseif strcmp(mtype,'s')
      title(['Deviation of E\{(x'')^',num2str(ord),'\} from \sigma^2+\mu^2+q^2/12'])
    end
    if strcmp(ptype,'m'), xlabel('\mu/q')
    elseif strcmp(ptype,'a'), xlabel('\sigma/q')
    end
    saveprobfig(plotno,['figp_11_5',setstr('a'-1+plotno),'.eps'])
  end %for mtype
end %for ord
