disp('Solving problem 13.10 ...')

close all
p=8; 
%Emin=-126; Delta=2^Emin;
Delta=1;
q=pow2(-(p-1))*Delta;
sigma=25*Delta; mu=30*Delta;
%
M=8; dx=q/M;
N=1e6;
x=sigma*randn(N,1)+mu;
[y,dcomp]=compress(x,Delta,'p');
%
nuFL=expand(q*round(y/q),Delta)-x;
figure(1)
[NB,X]=hist(nuFL,M*15); dx=mean(diff(X));
bar(X,NB/N/dx,1), shg
nuFLlimplot=0.25;
set(gca,'xlim',[-nuFLlimplot,nuFLlimplot],'ylim',[0,15])
xlabel(sprintf('N = %.1e',N))
saveprobfig(1,['figp_13_10a.eps'])
%
nuEXP=round(log2(abs(x)/Delta)-0.5)-(log2(abs(x)/Delta)-0.5);
figure(2)
[NB,X]=hist(nuEXP,2*M); dx=mean(diff(X));
bar(X,NB/N/dx,1), shg
nuEXPlimplot=0.6;
set(gca,'xlim',[-nuEXPlimplot,nuEXPlimplot],'ylim',[0,1.5])
xlabel(sprintf('N = %.1e',N))
saveprobfig(2,['figp_13_10b.eps'])
