disp('Solving problem 18.3 ...')

close all
N=100; B=16; p=12; q=2^(-(B-1));
power_gain=(2+2*((1-0.99)/(1-0.99^N))^2)/(1-0.99^2)
power_gain_FL=power_gain*.180
power_fix=power_gain*q^2/12
power_FL=power_gain_FL*2^(-2*p)*0.5^2

Nx=2e3; N=100; 
for qtype={'fix','FL'}
  qtype=qtype{1};
  if strcmp(qtype,'fix'), Q=qstruct('Name','Qfix','B',16,'fract',15);
  elseif strcmp(qtype,'FL') Q=qstruct('Name','QFL','p',12,'Emax',127,'Emin',-126);
  else error('Unknown quantization type')
  end
  qstructget(Q)
  y=0.5+[zeros(N,1);0.1*randn(Nx-N,1)]; x=zeros(size(y)); xq=zeros(size(y));
  for n=N+1:Nx-1
    zqn=roundq(y(n)-roundq(0.99^N*y(n-N),Q),Q);
    xq(n+1)=roundq(0.99*xq(n)+roundq((1-0.99)/(1-0.99^N)*zqn,Q),Q);
    zn=y(n)-0.99^N*y(n-N);
    x(n+1)=0.99*x(n)+(1-0.99)/(1-0.99^N)*zn;
  end
  powernu=mean((xq(4*N+1:end)-x(4*N+1:end)).^2)
end