function problem
disp('Solving problem 19.5 ...')

%clear
H=tf([2 -1/6,0],conv([1,-1/2],[1,1/3]),1,'variable','z^-1')
%H1=tf(1,[1,-1/2],1,'variable','z^-1')
%H2=tf(1,[1,1/3],1,'variable','z^-1')
%H12=H1+H2

qADC=0.001;
sigma=1;
N=1e6;

for sign='gs'
  if strcmp(sign,'g'), x=sigma*randn(N,1); 
  else x=sqrt(2)*sin(2*pi*[1:N]/100);
  end
  xq=qADC*round(x/qADC);
  y=filter(H.num{1},H.den{1},x);
  yxq=filter(H.num{1},H.den{1},xq);
  yq=yxq;
  %yq=qDAC*round(yxq/qDAC);
  disp(['signal: ',sign])
  boundyqerr=max(abs(yq(100:N)-y(100:N)))
  stdyqerr=std(yq(100:N)-y(100:N))
end