disp('Solving problem 20.4 ...')

close all
p=18;
S=2^(p); Erep=0;
n=1; Pnm1=1;
while Pnm1>0.00001
  n=n+1;
  Pnm1=Pnm1*(S-n+1)/S;
  Erep=Erep+(n-1)/S*Pnm1*n;
end %while
Lper=Erep/2; sqrtS=sqrt(S);
fprintf('Expected period length: %.0f, sqrt(N) ~ %.0f\n',Lper,sqrtS)
Q=qstruct(struct('p',p));
a=3.8; a=qfloat(a,Q);
y0=0.1; %initial value alg1: Np=271, alg2: Np=166, alg3: Np=108
%y0=.1111; %alg3: Np=379
y0q=qfloat(y0,Q);
fprintf('Init: '), num2bin(y0q,Q)
global N_for_test_only
if isempty(N_for_test_only), N=1000; else N=280; end
yN=zeros(N,1); yN(1)=y0q;
for eq=1:3 %type of equation
  figure(1)
  for k=1:N-1
    if eq==1
      str='y(k+1)=a*y(k)*(1-y(k))';
      yN(k+1)=qfloat(qfloat(a*yN(k),Q)*qfloat(1-yN(k),Q),Q);
    elseif eq==2
      str='y(k+1)=a*(y(k)*(1-y(k)))';
      yN(k+1)=qfloat(a*qfloat(yN(k)*qfloat(1-yN(k),Q),Q),Q);
    elseif eq==3
      str='y(k+1)=a*y-a*y(k)*y(k)';
      yN(k+1)=qfloat(qfloat(a*yN(k),Q)-qfloat(a*qfloat(yN(k)*yN(k),Q),Q),Q);
    end
    if k==1, disp(['Expression: ',str]), end
    pause(0) %allow ctrl/c
  end
  plot(yN,'linewidth',.5)
  xlabel('n'), ylabel('y')
  hold off, zoom on, shg
  %
  ind=find(yN==yN(end)); ind=[0;ind]; dy=length(yN)-ind(end-1);
  figure(2)
  if dy<N
    plot(yN(1:end-dy)-yN(1+dy:end))
    xlabel('n'), title([sprintf('0 = y(n) - y(n+%.0f)',dy),', expression: ',str])
    fprintf('Period length: %.0f\n',dy)
  else
    plot(yN(1:end))
    xlabel('n'), ylabel('y(n)')
    title(sprintf('Solution is not periodic for n<%.0f',N))
    fprintf('Solution is not periodic for n<%.0f\n',N)
  end
  hold off, zoom on, drawnow, shg
  if isempty(N_for_test_only)
    fprintf('Press any key ...'), pause, disp(' ')
  end
end
%dy, end
