disp('Solving Problem 4.14...')

if exist('samples_of_x.mat')
  load samples_of_x.mat
else
  Nx=1e5;
  x=2.5*randn(Nx,1)+4;
  save samples_of_x.mat x
  %hist(x,100), shg
end

Nx=length(x);
figure(1)
dx=.02;
X=-6+dx/2:dx:14;
[N,X]=hist(x,X); 
bar(X,N/Nx/dx)
title('f(x)')
saveprobfig(1,'figp_4_14a.eps')

q=1;
figure(2)
xp=q*round(x/q);
[Np,Xp]=hist(xp,X); 
bar(Xp,Np/Nx)
title('f(x'')')
saveprobfig(2,'figp_4_14b.eps')

nu=-.5+dx/2:dx:.5; fnu=zeros(size(nu));
for ii=1:length(X)
  [dummy,ind]=min(abs(round(X(ii))-X(ii)-nu));
  fnu(ind)=fnu(ind)+N(ii)/Nx/dx;
end
figure(3)
bar(nu,fnu)
title('f(\nu)')
saveprobfig(3,'figp_4_14c.eps')

xp1=mean(xp); xp2=mean(xp.^2); xp3=mean(xp.^3); xp4=mean(xp.^4);
x1=mean(x); x2=mean(x.^2); x3=mean(x.^3); x4=mean(x.^4);
xp1, x1corr=xp1, x1
xp2, x2corr=xp2-q^2/12, x2
xp3, x3corr=xp3-xp1*1/4*q^2, x3
xp4, x4corr=xp4-1/2*xp2*q^2-7/240*q^4, x4

