disp('Solving problem 9.6 ...')

close all
global N_for_test_only
if ~isempty('N_for_test_only'), N=N_for_test_only; L=N_for_test_only; 
else N=1024; L=1000;
end
tauv=[0:N];
l1=[1:L]'; l2=[1:L];
q=1; A=15*q;
R_nunu=zeros(size(tauv));
ii=0;
for tau=tauv
  ii=ii+1;
  R_nunu(ii)=R_nunu(ii)+q^2/(2*pi^2)*sum(sum( besselj(0,A*sqrt(l1(:,ones(1,L)).^2*(2*pi/q)^2 ...
    +l2(ones(L,1),:).^2*(2*pi/q)^2 + 2*l1*l2*(2*pi/q)^2*cos(tau/N*2*pi))) ...
    .*(-1).^(l1(:,ones(1,L))+l2(ones(L,1),:)+1)./(l1*l2) ));
  R_nunu(ii)=R_nunu(ii)+q^2/(2*pi^2)*sum(sum( besselj(0,A*sqrt(l1(:,ones(1,L)).^2*(2*pi/q)^2 ...
    +l2(ones(L,1),:).^2*(2*pi/q)^2 - 2*l1*l2*(2*pi/q)^2*cos(tau/N*2*pi))) ...
    .*(-1).^(l1(:,ones(1,L))-l2(ones(L,1),:))./(l1*l2) ));
  if ii==1, fprintf('Rmax = %.5f, L = %.0f\n',max(R_nunu),L), end
  if rem(ii,20)==0
    fprintf('.')
    %plot([-fliplr(tauv(2:N)),tauv],[fliplr(R_nunu(2:N)),R_nunu])
    %title(sprintf('Rmax = %.5f',max(R_nunu)))
    %drawnow
  end
end
disp(' ')
figure(1)
clf
plot([-fliplr(tauv(2:N)),tauv],[fliplr(R_nunu(2:N)),R_nunu]), %set(gca,'xlim',[-10,10])
hold on
xlim=get(gca,'xlim');
plot(xlim,q^2/12*[1,1],':')
plot(xlim,-q^2/12*[1,1],':')
hold off
saveprobfig(1,['figp_9_6.eps'])
