function display(x)
%DISPLAY  Display @qdata objects with printing object name.
%    DISPLAY(X) is called for the object X when the semicolon is not used
%    to terminate a statement.
%
%    See also DISP.

% Copyright (C) 2004 by JUHASZ Laszlo

% variable for space for extension
sp = ' ';
if length(x.data(1,:))>1
  sizstr=sprintf('  (%.0f x %.0f qdata)',size(x,1),size(x,2));
else
  sizstr='';
end
if prod(size(x))==1, xd=double(x); 
else xd = sprintf('(%.0f x %.0f)',size(x,1),size(x,2)); 
end
if isequal(get(0,'FormatSpacing'),'compact')
  disp([inputname(1),' = ',num2str(xd),sp(ones(1,30)),'QDSP: ',x.name,sprintf(', p = %.0f',qget(x.name,'Precision')),sizstr]);
  if size(x,2)==1, disp(x), end
else
  disp(' ')
  disp([inputname(1),' = ',num2str(xd),sp(ones(1,30)),'QDSP: ',x.name,sprintf(', p = %.0f',qget(x.name,'Precision')),sizstr]);
  %disp(' ');
  if length(x)==1, disp(x)
	else
		if prod(size(x))<=9
			for ii=1:size(x,1)
				for jj=1:size(x,2)
					if jj>1, fprintf('   '), end
					disp(subsref(x,struct('type','()','subs',{{ii,jj}})))
				end
			end
		end
	end
end