function y = ndims(x)
%NDIMS         Number of dimensions in @qdata objects.
%    N = NDIMS(X) returns the number of dimensions in the object X.
%    The number of dimensions in an object is always greater than
%    or equal to 2.  Trailing singleton dimensions are ignored.
%    Put simply, it is LENGTH(SIZE(X)).
%
%    See also QDATA/SIZE.

y = length(size(x));
