function x = addbfp(a,b,c,d,e)
%ADDBFP  numerical adding Big Floating Point Number Array
%   Z = addBFP(X, Y) adds BFP vectors X and Y.  The resulting
%   vector is length LENGTH(A)+LENGTH(B)+1
%
%   Z = addBFP(X, Y, M) adds BFP vectors X and Y, where the length of their
%   mantissas are other then 22 bits. M contains the length of segments.
%
%   Z = addBFP(X, Y, M, N) adds BFP vectors X and Y, where the length of teir
%   mantissas are other then 22 bits (it's rather M), and the number of the elements in the arrays
%   are differ from 5 (it is N).
%
%   Z = addBFP(X, Y, M, N, D) adds BFP vectors X and Y, where the length of their
%   mantissas are other then 22 bits (because they are M), and the number of the elements 
%   in the arrays differ from 5 (they are N). 
%   This will echo the steps of the multipy, and D sets the depth of the printing.
%
%   version number 1.5 beta version
%
%   Copyright 2004 Rvsz Sndor

%do nothing here: dll file