function demo3
clc
disp('Demonstration of denormalized segments in case of extended ''double'' numbers')
disp('with precision 66, ''standard'' Emin -1022 and ''fix'' rounding.')

for exp = -1020:-1:-1090
   % calculate length of mant
   if exp>=-1022
      mant = ones(1,66);
   else
      mant = ones(1,exp+1088);
      if isempty(mant), mant = 0; end
   end
   % feed with str2seg_core
   g = str2seg_core(1,mant,exp,3);
   for k = 1:length(g)
      [f,e] = log2(g(k));
      if f
         f = dec2bin(pow2(f,22),22);
         f(end+1) = 0;
         f(3:end) = f(2:end-1);
         f(2) = '.';
         fprintf('%23s @%5d ',f,e-1)
      else
         fprintf('%31s','0        ')
      end
   end
   fprintf('\n')
end
