function eredmeny = osztas(a,b,mant_hossz,num,d)
%osztas eloszt kt  Big Floating Point szmot
%   Z = osztas(X, Y) elosztja Xet s Yt. Az eredmny hossza 5elemu.
%
%   Z = addBFP(X, Y, mant_hossz) elosztja Xet s Yt ahol a szegmensek hossza mant_hossz
%
%   Z = addBFP(X, Y, mant_hossz, num) elosztja Xet s Yt ahol a szegmensek hossza mant_hossz s a szegmensek szma num
%
%   Z = addBFP(X, Y, mant_hossz, num, d) elosztja mint fent, s d szinten kirja a szmolst 
%
%   version number 0.3 beta version
%
%   Copyright 2004 Rvsz Sndor
    d=10;
    HIBAN = 3;
      
    if(ndims(a)~=2)
        error('a hibs, mert nem vector')
    end
    if(ndims(b)~=2)
        error('b hibs, mert nem vector')
    end    
    if(nargin<5)
        d=0;
    end
    if(nargin<4)
        num=5;
    end
    if(nargin<3)
        mant_hossz=22;
    end
    if(nargin<2)
        error('tul kevs bemeno adat');
    end    
        
    size_a = size(a);
    size_b = size(b);
    if(size_a(2)==1 & size_a(1)>1) a = a.'; end;
    if(size_b(2)==1 & size_b(1)>1) b = b.'; end;
    
    if((a(1)<0 & b(1)<0) | (a(1)>0 & b(1)>0))
        elojelezes = 1;
    else
        elojelezes = -1;
    end   
    a=abs(a);
    b=abs(b);
    oszto = b(1);
    eredmeny = zeros(1,num+HIBAN);
    maradek = a;
    for ii = 1:(num+HIBAN)
            
        %osztunk a legfelsot
        osztott = maradek(1)/oszto;
        
            
        %22 bitet tartunk csak meg, s az utolsbl egyet levonunk
        [osztott_m,osztott_e] = log2(osztott);
        osztott_szukseges_resz = floor(osztott_m * 2 ^ mant_hossz);
        osztott_szukseges_resz = osztott_szukseges_resz; %-1;
        if ii < (num+HIBAN), osztott_szukseges_resz = osztott_szukseges_resz-1; end
        %visszaalaktjuk
        osztott = osztott_szukseges_resz / 2 ^ mant_hossz * 2 ^ osztott_e;
        %eltroljuk az eredmnytmbben             
        %osztott = [osztott * 2 ^ -(mant_hossz*(ii-1)) 0 0 0 0];
        osztott = [osztott zeros(1,num + HIBAN -1)];
        eredmeny = addbfp(eredmeny,osztott,mant_hossz,num+HIBAN,d-2);
        eredmeny = eredmeny(1:num+HIBAN);
           
        %visszaszorzunk
        
         b_megnovelt = [b zeros(1, HIBAN)];
%        b_megnovelt(1:num) = b;
%        b_megnovelt(num+1) = 0;
        
        %visszaszorzott = mplBFP(b_megnovelt,eredmeny,mant_hossz,num+HIBAN,d-2);
        visszaszorzott = szorzas(b_megnovelt,eredmeny,mant_hossz,num+HIBAN,d-2);
        
        visszaszorzott = visszaszorzott(1:num+HIBAN);
           
        %kivonjuk
        
%        a_megnovelt(1:num) = a;
%        a_megnovelt(num+1) = 0;
         a_megnovelt = [a zeros(1, HIBAN)];
        
        maradek_out = addbfp(a_megnovelt,-visszaszorzott,mant_hossz,num+HIBAN,d-2);
           
        maradek = maradek_out(1:num+HIBAN);
           
   end 
 
   
   
   [maradek,maradek_exponens]= log2(eredmeny(num+1:length(eredmeny)));
   domore = 1;
   trunc = 0;
   ii = 1;
   while(domore & ii<length(maradek))
       domore = 0;
       if(maradek(ii) < 0.5 & maradek(ii) > 0)
           %lefel kerektnk
           trunc = 0;
       else
           if(maradek(ii) >= 0.5)
               %felfel kerektnk
               trunc = 1;
           else
               %maradek = 0;
               domore = 1;
               trunc = -1;
               ii = ii + 1;
           end
       end
   end
   
   %trunc irany
   if(trunc==1)
       %felfel
       eredmeny(num+1) = 0.75 * 2^maradek_exponens(1);
   else
        if(trunc == 0)
            %lefel
            eredmeny(num+1) = 0.25 * 2^maradek_exponens(1);
        else
            %nulla volt
            eredmeny(num+1) = 0.0;
        end
   end
   
   
   eredmeny = elojelezes * eredmeny(1:num+1);
   return  
  