function Y = segs2double(X,dim)
%SEGS2DOUBLE  Converts segments to double number

if nargin<2, dim=[]; end, if isempty(dim), dim=1; end
sizex = size(X);
sizx = sizex; sizx(dim)=[];
%if isdscalar(sizx), sizx = [sizx]; end
if dim==1, Y = 0*X(1,:,:); else Y=0*X(:,:,1); end
for ii = 1 : sizex(dim)
  m = 2^((ii-1)*22);
  if dim==1
    Y = Y + X(ii,:,:) ./ m;
  else %at the end
    if length(sizex)==2, Y = Y + X(:,ii) ./ m;
    elseif length(sizex)==3, Y = Y + X(:,:,ii) ./ m;
    else error('Something is wrong')
    end
  end
end
if dim==1
  if length(sizex)==2, Y=permute(Y,[2,1]);
  elseif length(sizex)==3, Y=permute(Y,[2,3,1]);
  else error('something wrong')
  end
end