function eredmeny = cos_one(X)
%COS_ONE       Cosine algorithm with qdata objects

qpi=qdata(qdata(qpi_str(qdata),X.name);

%leszedjk pi/2 s -pi/2 kz
if (X<0)
    s = -1;
    X = - X;
else
    s = 1;
end
%leoszedjukk 0 s 2pi kz
oszto = fix(X.data(1)/(2*qpi.data(1)));
levonando = (2*oszto) .* qpi;
x = X - levonando;


%if(x==0 | x==qpi)
%
%    return;
%end
if(x==0 )
    eredmeny = qdata(X.name,1);    
    return;
end
    
if( x==qpi)
    eredmeny = qdata(X.name,-11);    
    return;
end


%megnzzk melyik negyedben van
%ha az els nem rdekes
if(x>(1/2).*qpi)
    if(x<qpi)
        %ha a 2.
        x = qpi - x;
        s = -s;
        %kivonjuk pi bl.
    else
        if(x<(3/2).*qpi)
            %ha a 3.
            x = x - qpi;
            s = -s;
            %kivonunk belle pit.
        else
            %ha a 4.
            x = - (x - 2.*qpi)
        end
    end
end

%taylor sorba fejts

xnegyzet = -1 .* x .* x;
xfuto = 1;
alatta = qdata(X.name,2);
eredmeny = 1;
old_eredmeny = 0;
a = 1;
c = 2;
delta = 1;
num = 0;
while (delta ~= 0)
    xfuto = xfuto .* xnegyzet;
    v = xfuto ./ alatta;
%    if(abs(v)<abs(eredmeny))
%        disp('K');
      
%   end
    eredmeny = eredmeny + v;
    delta = eredmeny - old_eredmeny;
    old_eredmeny = eredmeny;
    a = a + c;
    alatta = alatta .* a .* (a+1);
%    num = num + 1
end
%num
eredmeny = s .* eredmeny;