function A = subsasgn(a,s,b)
%SUBSASGN  SUBSASGN Subscripted assignment.
%
%	For more inforamtion see subsasgn



% generating quantizer property short-code for 'double'
persistent qcode
if ~isempty(a.name)
    qcode = qdspdemo('quantizers',a.name);
end
    

%   qcode = ['SEGNUM=[3];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[53];',...
%         'LEADINGBIT=''hidden'';FRACTION=[52];INVSIGNAL=''neglect+nan'';',...
%         'OVERFLOW=''inf'';OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
%         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
%         'EMAX=[1023];EMIN=[-1022];'];

eval(qcode);
aname = a.name;
a = a.data;

% checkin b data
if ~isempty(b.name)
    if ~strcmp(aname,b.name)
        error('QDSP:SUBASGN:argchk','assigned object has different quantizer');
    end
    bname=b.name;
    b=b.data;
    orsizb = size(b);
else
    %b is a double
    % convert 'b' argument to segments
    % save original size of 'b'
    orsizb = size(b);
    % generating segnum - it's always 3 in case of 'double'
    segnb = 3;
    % convert 'b' to column vector
    b = b(:);
    % fill up the variable 'z' with segment-transformed values of 'b'
    for k = 1:length(b)
       z(:,k) = double2seg(b(k)).';
    end
    % 'z' is a two-dimensional array with segments in the rows and numbers
    % in the columns
    % making a fake-object from 'b' and put back the data of 'z' to the
    % 'data' field
    z = reshape(z,[SEGNUM,orsizb]);
    b = z;
    bname = a.name;    
end
    
% filtering out empty matrix
if isempty(a)
    a = b;
else
    orsiza = size(a);
    % calculating the number of segments in 'a'
    %segna = orsiza(1);
    % calculating the real size WITHOUT segments - the length of size is
    % minimum 2 so the '2:end' expression is always correct.
    orsiza = orsiza(2:end);
    orsizb = orsizb(2:end);
    % convert to two dimension
    a = reshape(a,[SEGNUM,prod(orsiza)]);
    b = reshape(b,[SEGNUM,prod(orsizb)]);
    e = 'majom';
    %most van 2 sorvektor BFPkkel.
    %ltrehozunk  SEGNUM-nyi kln 2 vektort
    for i=1:SEGNUM
        aa=a(i,:);%i.szegmens a vektora
        bb=b(i,:);%i.szegmens b vektora
        %2ds szegmensdarab amit visszashapelnk
        if(isdscalar(orsiza))
            orsiza = [1 orsiza];
        end
        c = reshape(aa,[ orsiza]);
        if(isdscalar(orsizb))
            orsizb = [1 orsizb];
        end
        d = reshape(bb,[ orsizb]);
       
        %minden segmens kln helyen
        %ezutn szegmensenknt vgrehajtjuk a subsref-et.
        ret=subsasgn(c,s,d);
        orsizret = size(ret);
        ret_res = reshape(ret,[1,prod(orsizret)]);
        if((prod(size(e))==5)&(e=='majom'))
            e=ret_res;
        else
            e = cat(1,e,ret_res);
%             e = cat(ndims(ret)+1,e,ret);
        end
    end
    e = reshape(e,[SEGNUM,orsizret(2:end)]);
    A = qdata(struct('name',aname,'data',e));
end