function eredmeny = sin_one(X)
%SIN_ONE    Sine for QDATA with QDATA objects.
%   SIN(X) is the sine of the elements of X.

qpi=qdata(qpi_str(qdata),X.name);
%leszedjk pi/2 s -pi/2 kz
if (X<0)
    s = -1;
    X = - X;
else
    s = 1;
end
%leszedjk 0 s 2pi kz
oszto = fix(X.data(1)/(2*qpi.data(1)));
levonando = (2*oszto) .* qpi;
x = X - levonando;

if(x==0)
    eredmeny = x;
    return;
end
if(x == qpi)
    eredmeny = 0.*x;
    return;
end

%megnzzk melyik negyedben van
%ha az els nem rdekes
if(x>(1/2).*qpi)
    if(x<qpi)
        %ha a 2.
        x = qpi - x;
        %kivonjuk pi bl.
    else
        if(x<(3/2).*qpi)
            %ha a 3.
            x = x - qpi;
            s = -s;
            %kivonunk belle pit.
        else
            %ha a 4.
            x = - (x - 2.*qpi)
            s = -s;
        end
    end
end

%taylor sorba fejts

xnegyzet = -1 .* x .* x;
xfuto = x;
alatta = qdata(X.name,6);
eredmeny = x;
old_eredmeny = 0;
a = 2;
c = 2;
delta = x;
num = 0;
while (delta ~= 0)
    xfuto = xfuto .* xnegyzet;
    v = xfuto ./ alatta;
    eredmeny = eredmeny + v;
    delta = eredmeny - old_eredmeny;
    old_eredmeny = eredmeny;
    a = a + c;
    alatta = alatta .* a .* (a+1);
    num = num + 1;
end
%num
eredmeny = s .* eredmeny;