function B = subsref(a,s)
%SUBSREF Subscripted reference.
%
%	For more information see subsref

if strcmp(s(1).subs ,':')
  warning('Not Yet implemented subsref with : ');
elseif strcmp(s(1).type ,'.')&strcmpi(s(1).subs ,'data')
  struc=struct(a); B=struc.data; 
  if length(s)>1, B=subsref(B,s(2:end)); end
  return
elseif strcmp(s(1).type ,'.')&strcmpi(s(1).subs ,'name')
  struc=struct(a); B=struc.name; 
  return
elseif strcmp(s(1).type ,'.')&strcmpi(s(1).subs ,'bin')
  B=get(a,'bin');
  return
end

% generating quantizer property short-code for 'double'
persistent qcode
if ~isempty(a.name)
    qcode = qdspdemo('quantizers',a.name);
end
    

%   qcode = ['SEGNUM=[3];TYPE=''floating-point'';CODING=''sign-mag'';PRECISION=[53];',...
%         'LEADINGBIT=''hidden'';FRACTION=[52];INVSIGNAL=''neglect+nan'';',...
%         'OVERFLOW=''inf'';OFSIGNAL=''warning+count'';UNDERFLOW=''gradual'';',...
%         'UFSIGNAL=''warning+count'';ROUNDING=''round'';TREATHALF=''toeven'';',...
%         'EMAX=[1023];EMIN=[-1022];'];

eval(qcode);
aname = a.name;
a = a.data;

% filtering out empty matrix
if isempty(a), out = []; return, end

orsiza = size(a);
% calculating the number of segments in 'a'
%segna = orsiza(1);
% calculating the real size WITHOUT segments - the length of size is
% minimum 2 so the '2:end' expression is always correct.
orsiza = orsiza(2:end);
%convert to two dimensions
while size(a,1)<SEGNUM, a=[a;0*a(1,:,:)]; end %IK
a = reshape(a,[max(size(a,1),SEGNUM),prod(orsiza)]); %** javitas

e = 'majom';
%most van egy sorvektor BFPkkel.
%ltrehozunk  SEGNUM-nyi kln vektort
for i=1:SEGNUM
    b=a(i,:);
    %2ds szegmensdarab amit visszaformzunk
    if(isdscalar(orsiza))
        orsiza = [orsiza 1];
    end
    c = reshape(b,orsiza);
    %minden segmens kln helyen;
    %ezutn szegmensenknt vgrehajtjuk a subsref-et.
    d=subsref(c,s);
    orsizd = size(d);
    d_res = reshape(d,[1,prod(orsizd)]);
    if((prod(size(e))==5)&(e=='majom'))
        e=d_res;
    else
        e = cat(1,e,d_res);
    end
end
e = reshape(e,[SEGNUM,orsizd]);
B = qdata(struct('name',aname,'data',e));
