function iseq=isqequal(Q1,Q2)
%ISQEQUAL  Compare two quantizers

error(nargchk(2,2,nargin))
if isstr(Q1), Q1p=qget(Q1);
elseif isstruct(Q1), Q1p=Q1;
else error('Q1 is neither a string nor a structure')
end
if isstr(Q2), Q2p=qget(Q2);
elseif isstruct(Q2), Q2p=Q2;
else error('Q2 is neither a string nor a structure')
end
Q1=Q1p; Q2=Q2p;
Q1p.name=''; Q1p.rights='';
Q2p.name=''; Q2p.rights='';
if strcmp(Q1p.roundingdir,'trunc')&strcmp(Q2p.roundingdir,'floor')
  Q1p.roundingdir='floor';
elseif strcmp(Q2p.roundingdir,'trunc')&strcmp(Q1p.roundingdir,'floor')
  Q2p.roundingdir='floor';
end
if strcmp(Q1p.treathalf,'trunc')&strcmp(Q2p.treathalf,'floor')
  Q1p.treathalf='floor';
elseif strcmp(Q2p.treathalf,'trunc')&strcmp(Q1p.treathalf,'floor')
  Q2p.treathalf='floor';
end
if 1|(nargout>0)
  iseq=isequal(Q1p,Q2p);
else
  if ~isequal(Q1p,Q2p)
    if ~isequal(Q1p.type,Q2p.type)
      fprintf(['Different types: ''',Q1p.type,''', ''',Q2p.type,'''\n'])
      return
    end
    fn1=fieldnames(Q1p);
    fn2=fieldnames(Q1p);
    if ~isequal(fn1,fn2), fprintf('Properties differ\n'), Q1, Q2, return, end
    %Q1, Q2,
  end
end
