function k = b_add_test(N)
%B_ADD_TEST

disp('Test b_add_test is running ...')

if nargin<1, N=[]; end, if isempty(N), N=1000; end
if isstr(N), N=str2num(N); end
k=0;
while k<N
  k=k+1;
  if k==1, fprintf('k = %.0f',k)
  elseif rem(k,50)==0, fprintf(' %.0f',k)
  end
  if (rem(k,1000)==0)|(k==N), fprintf('\n'), end
  x=qdata(1,'BigFP');
  szam1 = randn(x);
  szam2 = randn(x);
  qdata_sum = szam1+szam2;
  %
  szam1_2=qdata_sum-szam2;
  if finite(double(szam1_2))&(abs(szam1_2-szam1)>(lsb(szam1_2)+lsb(qdata_sum))/2)
    szam1, szam1_2, szam1_2-szam1
    error('Cannot restore number after addition')
  end
  %
  bin_sum = b_add(szam1,szam2);
  if isnan(double(bin_sum))&isnan(double(qdata_sum))
  elseif ~isequal(bin_sum,qdata_sum)
    disp(' ')
    szam1, szam2
    x1=double(szam1); x2=double(szam2); sum=qdata(x1+x2)
    bin_sum, qdata_sum
    save
    error('Addition error')
  end
end
fprintf('Addition test OK\n')
