function k = b_divide_test(N)
%B_DIVIDE_TEST

disp('Test b_divide_test is running ...')

if nargin<1, N=[]; end, if isempty(N), N=1000; end
if isstr(N), N=str2num(N); end
k=0;
while k<N
  k=k+1;
  if k==1, fprintf('k = %.0f',k)
  elseif rem(k,50)==0, fprintf(' %.0f',k)
  end
  if (rem(k,1000)==0)|(k==N), fprintf('\n'), end
  x=qdata(1,'BigFP');
  szam1 = randn(x);
  szam2 = randn(x);
  qdata_ratio = szam1/szam2;
  %
  szam1_2=qdata_ratio*szam2;
  if finite(double(szam1_2)) & ...
      abs((szam1_2-szam1)/szam1_2)>(lsb(szam1_2)/abs(szam1_2)+lsb(qdata_ratio)/abs(qdata_ratio))/1.99
    szam1, szam1_2, szam1_2-szam1
    error('Cannot restore number after multiplication')
  end
  %
  bin_ratio = b_divide(szam1,szam2);
  if isnan(double(bin_ratio))&isnan(double(qdata_ratio))
  elseif ~isequal(bin_ratio,qdata_ratio)
    szam1, szam2
    x1=double(szam1); x2=double(szam2); ratio=qdata(x1/x2)
    bin_ratio, qdata_ratio
    save
    error('Division error')
  end
end
fprintf('Division test OK\n')
