function k = b_times_test(N)
%B_TIMES_TEST

disp('Test b_times_test is running ...')

if nargin<1, N=[]; end, if isempty(N), N=1000; end
if isstr(N), N=str2num(N); end
k=0;
while k<N
  k=k+1;
  if k==1, fprintf('k = %.0f',k)
  elseif rem(k,50)==0, fprintf(' %.0f',k)
  end
  if (rem(k,1000)==0)|(k==N), fprintf('\n'), end
  x=qdata(1,'BigFP');
  szam1 = randn(x);
  szam2 = randn(x);
  qdata_product = szam1*szam2;
  %
  szam1_2=qdata_product/szam2;
  if isfinite(double(szam1_2)) & ...
      abs((szam1_2-szam1)/szam1_2)>(lsb(szam1_2)/abs(szam1_2)+lsb(qdata_product)/abs(qdata_product))/1.99
    szam1, szam1_2, szam1_2-szam1
    error('Cannot restore number after multiplication')
  end
  %
  bin_product = b_times(szam1,szam2);
  if ~isequal(bin_product,qdata_product)
    disp(' ')
    szam1, szam2
    x1=double(szam1); x2=double(szam2); product=qdata(x1*x2)
    bin_product, qdata_product
    save
    error('Multiplication error')
  end
end
fprintf('Multiplication test OK\n')
