function err = check_overflow(x,s)
%CHECK_OVERFLOW    Checker function for the 'overflow' property

% Copyright (C) 2003 by JUHASZ Laszlo

err = '';
if strcmp(s.type,'fixed-point') & strcmp(x,'inf')
   err = '''inf'' is available only for type ''floating-point''.';
   return
elseif strcmp(s.type,'floating-point') & (strcmp(x,'modular') | strcmp(x,'triang'))
   err = '''modular'' and ''triang'' are available only for type ''fixed-point''.';
   return
end
