function y = def_minimum(s)
%DEF_MINIMUM          Default generator function for the 'minimum' property

% Copyright (C) 2003, 2004 by JUHASZ Laszlo

switch s.type
case 'fixed-point'
  Exp=(s.precision-s.fractionbits);
  if strcmp(s.coding,'twos-comp'), y=-(pow2(Exp));
  elseif s.precision<=53, y=-(pow2(Exp)-pow2(-s.fractionbits));
  else
    y=[];
    for ii=1:ceil(s.precision/22)
      if ii<s.precision/22, y=[y;-(pow2(Exp)-pow2(Exp-22))];
      else y=[y;-(pow2(Exp)-pow2(Exp-rem(s.precision,22)))];
      end
    end
  end
case 'floating-point'
   y=[];
otherwise error('Internal error 2')
end
