%FFTD_TEST

%clear;
testqmake;
%clc;
disp('Test fftd_test is running ...')

fs = 32;
t = 0:fs-1;
f = qdata(1,'BigFP');
tic;
adat_vektor = 2 / fs * t;
qpi_f = qpi .* f;
adat = qpi_f .* adat_vektor; % 2 * pi * f * t / fs;
x = sin(adat);
time=toc;
disp('Calculating sine function at fs points');
time


tic;
Xm = fft(sin(2*pi*1/fs*t));
time=toc;
disp('Execution time of Matlab''s fft:');
time


tic;
Xd= fftd(x);
disp('QDSP fft with qdata''s');
time=toc;

%  tic;
%  X2 = fftd(sin(2*pi*1/fs*t));
%  time=toc;
%  disp('n fftm double szmokkal');
%  time

disp('Input data: x, Matlab''s fft: Xm, QDSP fft: Xd');

%plot(x);
%figure;
%plotfft(Xd,'r');
%figure;
%plot(abs(X2));

%disp('A kt fft klnbsge qdata-ban:')
%A=Xm+Xd;
%disp('A kt fft klnbsge double-ban:')
%B=double(Xd) + Xm;

%plot(real(A));
%figure;
%plot(imag(A));