function qdspdemo_learn
%QDSPDEMO_LEARN Teach using of QDSP
%
%create quantizers
%testqmake
qclear -all
disp('-------------------------------------- ')
disp('This is an introduction to the basic use of QDSP')
%fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('First lesson / 1')
disp(' ');
disp('Create a quantizer')
disp('qmake test_quantizer')
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
qmake test_quantizer
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('First lesson / 2')
disp(' ');
disp('Look at the quantizer created')
disp('qget')
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
clc, qget
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Second lesson / 1')
disp(' ');
disp('Create qdata object from a double number')
disp('a = 6')
a = 6;
disp('A = qdata(''test_quantizer'',a)')
disp(' ');
A = qdata(a,'test_quantizer')
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Second lesson / 2')
disp(' ');
disp('Create random qdata object from segment vector')
disp('B = ujszam(22,2) -- 22bit 2 szegmens') 
B = testqdsp('ujszam',22,2);
disp 'B = qdata(struct(''name'',''test_quantizer'',''data'',B.''))'
B = qdata(struct('name','test_quantizer','data',B.'))
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Second lesson / 3')
disp(' ');
disp('Create qdata object from string')
disp 'B = qdata(''tesztkvantalo'',''1.000011111010010110010110b'')'
B = qdata('1.000011111010010110010110b','test_quantizer')
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Third lesson / 1')
disp(' ');
disp('Addition, multiplication, and division')
disp('A-B')
A-B
disp('A+B')
A+B
disp('A.*B')
A.*B
disp('A./B')
A.*B
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Third lesson / 2')
disp(' ');
disp('sine cosine')
disp('sin(A)')
sin(A)
disp('cos(A)')
cos(B)
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Fourth lesson / 1')
disp(' ');
disp('sine and cosine #2')
disp('sin(A) ^ 2 + cos(A) ^ 2')
sin(A)*sin(A)+cos(A)*cos(A)
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Fourth lesson / 2')
disp(' ');
disp('(A)*(B)-(B)*(A)')
A.*B-B.*A
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Fifth lesson / 1')
disp(' ');
disp('Creating an array')
disp(' ');
disp ('testqmake')
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%testqdsp('testqmake')
%qmake('BigFP')
%qset BigFP precision 110 fraction 109 expbits 11 emax 1023 emin -1022 expbias 1023
qpi = qdata(qpi_str(qdata),'BigFP');
qhalfpi = qdata(qpi_str(qdata),'BigFP')./2;
disp('A = qpi')
A = qpi
disp('A(5,2) = qhalfpi')
A(5,2) = qhalfpi
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
disp('-------------------------------------- ')
disp('Fifth lesson / 2')
disp(' ');
disp('Sine of the array')
disp('sin(A)')
sin(A)
disp('Thank you.')
fprintf('\nPress any key to continue ...'), pause, disp(' ') 
%---------------------------------------------------------
return
