function test_bin2num
%TEST_BIN2NUM  Test basic conversions

qclear
ic=0;
for Q={qmake('name','Q1','Bits',32),qmake('name','Q2','Bits',32,'fraction',31),qmake('name','Q3','Bits',16,'fraction',10)}
  Q=Q{1};
  ic=ic+1;
  if ic==1
    binv={'0b','000.0b','1b','1111 1111b','0111 1111 1111 1111 1111 1111 1111 1111b',...
    '1000 0000 0000 0000 0000 0000 0000 0000',...
    '1111 1111 1111 1111 1111 1111 1111 1110','1111 1111 1111 1111 1111 1111 1111 1111'};
  elseif ic==2
    binv={'0b','000.0b','.1b','1.111 1111b','0.1111 1111 1111 1111 1111 1111 1111 111b',...
      '1.0000 0000 0000 0000 0000 0000 0000 000',...
      '1.1111 1111 1111 1111 1111 1111 1111 110','1.1111 1111 1111 1111 1111 1111 1111 111'}
  elseif ic==3
    binv={'0b','000.0b','.1b','1.1111111b','0.1111111111b',...
      '1.0000 0000 00','1.1111 1111 10','1.1111 1111 11'}
  end
  for bin=binv
		string=bin{1};
		fprintf(['Quantizer%.0f, %.0f.%.0f\n'],ic,qget(Q,'Bits'),qget(Q,'Fraction'))
    longstring=string; ind=find((longstring==' ')|(longstring=='b')); longstring(ind)='';
		point=find(longstring=='.');
		if ~isempty(point)
			longstring=[longstring,setstr('0'*ones(1,qget(Q,'fraction')-(length(longstring)-point)))]; 
      longstring(point)='';
      longstring(ismember(longstring,'()'))='';
    end
		if any(ismember(longstring(1),'to'))
			longstring=[longstring(1),setstr('1'*ones(1,length(longstring)-1-qget(Q,'Bits'))),longstring(2:end)];
		else
			longstring=[setstr('0'*ones(1,qget(Q,'Bits')-length(longstring))),longstring];
		end
		string, qdatanum=bin2num(bin{1},Q)
    if length(longstring)>length(qdatanum.bin), longstring=longstring(end-length(qdatanum.bin)+1:end); end
		if ~strcmp(qdatanum.bin,longstring)
			qdatabin=qdatanum.bin, longstring
			error('Strings differ')
		end
		pause
  end %for bin
	%qclear
end %for Q

Q = qmake('name','Q','type','fixed-point','B',32,'fract',12);
a = bin2num('1000 0000 0000 0000 0000.0000 0000 0000',Q)
bin2num(num2bin(a,Q),Q)
qclear