function eredmeny = ujszam(L,N,expo)
%UJSZAM  MAKE new random segmented number
%
%   eredmeny = ujszam(L,N,expo), column vector
%     L = length of segment
%     N = number of segments
%     expno = exponent

if nargin<3, expno=0; end
if nargin<2, N=5; end
if nargin<1, L=22; end

szam = '1';
for k = 2 : L*N
    if(rand(1) > 0.5)
        szam(k) = '1';
    else
        szam(k) = '0';
    end
end

if (nargin < 3)
    expo = L;
end

for k = 1 : N
    honnan = (k-1)*L + 1;
    hova = (k-1)*L + L;
    eredmeny(k,1) = bin2dec(szam(honnan:hova));
end

s = sign(randn(1));
if(s == 0) s = 1; end;
exponens = floor(randn(1)*expo);
eredmeny = s .* eredmeny .* 2 ^ (exponens-L);
