function tout=upperlower(tin)
%UPPERLOWER Set upper/lower case of quantizer

if ~isstruct(tin), tout=tin; return, end

for ii=1:length(tin)
  t=tin(ii);
  if isfield(t,'name'), to.Name=t.name; t=rmfield(t,'name'); end
  if isfield(t,'notes'), to.Notes=t.notes; t=rmfield(t,'notes'); end
  if isfield(t,'rights'), to.Rights=t.rights; t=rmfield(t,'rights'); end
  if isfield(t,'type'), to.Type=t.type; t=rmfield(t,'type'); end
  if isfield(t,'coding'), to.Coding=t.coding; t=rmfield(t,'coding'); end
  if isfield(t,'precision'), to.Precision=t.precision; t=rmfield(t,'precision'); end
  if isfield(t,'leadingbit'), to.LeadingBit=t.leadingbit; t=rmfield(t,'leadingbit'); end
  if isfield(t,'fractionbits'), to.FractionBits=t.fractionbits; t=rmfield(t,'fractionbits'); end
  if isfield(t,'nansignal'), to.NaNSignal=t.nansignal; t=rmfield(t,'nansignal'); end
  if isfield(t,'overflow'), to.OverFlow=t.overflow; t=rmfield(t,'overflow'); end
  if isfield(t,'ofsignal'), to.OFSignal=t.ofsignal; t=rmfield(t,'ofsignal'); end
  if isfield(t,'underflow'), to.UnderFlow=t.underflow; t=rmfield(t,'underflow'); end
  if isfield(t,'ufsignal'), to.UFSignal=t.ufsignal; t=rmfield(t,'ufsignal'); end
  if isfield(t,'roundingdir'), to.RoundingDir=t.roundingdir; t=rmfield(t,'roundingdir'); end
  if isfield(t,'treathalf'), to.TreatHalf=t.treathalf; t=rmfield(t,'treathalf'); end
  if isfield(t,'expcoding'), to.ExpCoding=t.expcoding; t=rmfield(t,'expcoding'); end
  if isfield(t,'expbits'), to.ExpBits=t.expbits; t=rmfield(t,'expbits'); end
  if isfield(t,'expbias'), to.ExpBias=t.expbias; t=rmfield(t,'expbias'); end
  if isfield(t,'emax'), to.ExpMaximum=t.emax; t=rmfield(t,'emax'); end
  if isfield(t,'emin'), to.ExpMinimum=t.emin; t=rmfield(t,'emin'); end
  if isfield(t,'minimum'), to.Minimum=t.minimum; t=rmfield(t,'minimum'); end
  if isfield(t,'maximum'), to.Maximum=t.maximum; t=rmfield(t,'maximum'); end
  if isfield(t,'dither'), to.Dither=t.dither; t=rmfield(t,'dither'); end
  if isfield(t,'qnoise'), to.QNoise=t.qnoise; t=rmfield(t,'qnoise'); end
  if isfield(t,'operation'), to.Operation=t.operation; t=rmfield(t,'operation'); end
  if length(fieldnames(t))>0
    fn=fieldnames(t);
    error(['Unrecognized field ''',fn{1},''' in structure'])
  end
  if ii==1, tout=to; else tout=[tout,to]; end
end