function test_resfiltq
%TEST_RESFILTQ

global N_for_test_only

num0=[0,ones(1,8)/8]; den0=[1]; zm=[];
den0=[1,-0.28,0.19,0.7]; num0=[0.7,0.19,-0.28,1];
[wm,rm,zm]=tf2res(num0,den0);
F=10; df=0.02;
if ~isempty(N_for_test_only), df=.1; end
N=500;
for alg={'coupled','real','complex'}
  alg=alg{1}
  fv=[]; H=[]; ic=0; 
  for f=[df:df:1/4-df/2]
    ic=ic+1; fv(ic)=f;
    x=sin([1:N]*2*pi*f);
    y=resfiltq(wm,rm,zm,x,[],[],struct('algorithm',alg));
    figure(1), plot(y), set(gca,'ylim',1.1*[-1,1]), drawnow, shg
    Tp=1/f;
    H(ic)=sqrt(2*mean(y(end-[0:round(Tp*round((N/2-1)/Tp))-1]).^2));
    figure(2), plot(fv,H), drawnow, shg
  end
end %alg
